//--------------------------------------------------------------------
//
// op8_4.cpp
//
// Program som gjr om en tallstreng til et tall. P samme mte som 
// for atoi(), atol() og atof() vil andre tegn bli godtatt bak tallet, 
// men ikke foran.
//
#include <iostream>
#include <cstdlib>
#include <cctype>
#include <string>
using namespace std;

void instruksjoner();
bool strengTilTall(const string streng, double &tallet);
bool strengTilTall(const string streng, float &tallet);
bool strengTilTall(const string streng, int &tallet);
bool strengTilTall(const string streng, long int &tallet);
bool testTall(const string str);

int main()
{
  instruksjoner();

  string tallStreng;
  
  cout << "Skriv inn et tall : ";
  cin >> tallStreng;
  
  int     tallI;
  float   tallF;
  bool heltallOK = strengTilTall(tallStreng, tallI);
  bool flyttallOK = strengTilTall(tallStreng, tallF);

  if (heltallOK) cout << "Som heltall: " << tallI << endl;
  if (flyttallOK) cout << "Som flyttall: " << tallF << endl;
  if (!heltallOK && !flyttallOK) {
    cout << "Feil: Du skrev ikke noe gyldig tall" << endl;
    }
  return 0;
} // main

//--------------------------------------------------------------------
//
// Funksjon som finner om strengen kan tolkes som tall eller ikke
//
bool testTall(
  const string str)      // Inn
{
  int i = 0;
  while (str.at(i) == ' ') i++;
  if (str.at(i) == '+' || str.at(i) == '-') i++;
  if (isdigit(str.at(i)) || str.at(i) == '.') return true;
  else return false;
} // testTall

//--------------------------------------------------------------------
//
// Funksjon som gir tallverdien av en tallstreng
//
// Returnerer : false hvis feil oppstod
//              true hvis ok
//
bool strengTilTall(
  const string streng,   // Inn
  int        &tallet)    // Ut
{
  tallet = atoi(streng.c_str());
  if (tallet != 0 || testTall(streng)) return true;
  else return false;
} // strengTilTall  

//--------------------------------------------------------------------
//
// Funksjon som gir tallverdien av en tallstreng
//
// Returnerer : false hvis feil oppstod
//              true hvis ok
//
bool strengTilTall(  
  const string streng,   // Inn
  long int   &tallet)    // Ut
{
  tallet = atol(streng.c_str());
  if (tallet != 0 || testTall(streng)) return true;
  else return false;
} // strengTilTall  


//--------------------------------------------------------------------
//
// Funksjon som gir tallverdien av en tallstreng
//
// Returnerer : false hvis feil oppstod
//              true hvis ok
//
bool strengTilTall(
  const string streng,   // Inn
  float      &tallet)    // Ut
{
  double dTallet = atof(streng.c_str());
  tallet = dTallet;
  if (tallet != 0.0 || testTall(streng)) return true;
  else return false;
} // strengTilTall  

//--------------------------------------------------------------------
//
// Funksjon som gir tallverdien av en tallstreng
//
// Returnerer : false hvis feil oppstod
//              true hvis ok
//                 
bool strengTilTall(
  const string streng,   // Inn
  double     &tallet)   // Ut
{
  tallet = atof(streng.c_str());
  if (tallet != 0 || testTall(streng)) return true;
  else return false;
} // strengTilTall

//--------------------------------------------------------------------
//
// instruksjoner
//
void instruksjoner()
{
  cout << "Du skriver inn en tallstreng og jeg skal regne ut\n";
  cout << "hva tallet er.\n";
} // instruksjoner

/* Kjreresultater

Du skriver inn en tallstreng og jeg skal regne ut
hva tallet er.
Skriv inn et tall : 4567.83
Som heltall: 4567
Som flyttall: 4567.83

*/
