//-------------------------------------------------------------------
//
// op9_1
//
// Et program som leser temperaturmlinger, plasserer
// dem i en tabell, og beregner middeltemeraturen.
//

#include <iostream>
#include <iomanip>
using namespace std;

const int maksAntallMaalinger = 366;
const int verdierPrLinje = 5;                  
const int presisjon = 5;
const int vidde = 10;

double gjSnitt(const double *tabell, int antall);
void   lesData(int antall, double *tabell);                   
void   skrivData(const double *tabell, int antall);
int    lesTallIIntervall(int nedre, int ovre);
void   skrivFlyttall(double tall, int presisjon, int vidde);

//-------------------------------------------------------------------
int main()
{
  double   temp[maksAntallMaalinger];
  int      antallMaalinger;
  
  cout << "Hvor mange mlinger har du? ";
  antallMaalinger = lesTallIIntervall(0, maksAntallMaalinger);
  
  lesData(antallMaalinger, temp);
  cout << "Antall mlinger: " << antallMaalinger;
  cout << " Middelverdi: " << gjSnitt(temp, antallMaalinger) << endl;
  cout << "Her er alle verdiene: ";                
  skrivData(temp, antallMaalinger);
  
  return 0;
} // main

//-------------------------------------------------------------------
//
// Leser dataene.
//
void lesData(
  int       antall,       // Inn
  double   *tabell)       // Ut

{
  int nr;
  for (nr = 0; nr < antall; nr++) {
    cin >> tabell[nr];
    }
} // lesData

//-------------------------------------------------------------------
//
// Beregner gjennomsnittet av tabellverdiene
//
double gjSnitt(
  const double *tabell,   // Inn
  int           antall)   // Inn
{

  double middel = 0.0;
  int    nr;

  for (nr = 0; nr < antall; nr++) {
    middel += tabell[nr];
    }
  if (antall > 0) middel /= antall;
  return middel;
} // gjSnitt              

//-------------------------------------------------------------------
//
// Skriver ut tabellverdiene
//
void skrivData(
  const double *tabell,   // Inn
  int           antall)   // Inn
{
  int nr;                          
  for (nr = 0; nr < antall; nr++) {  
    if (nr % verdierPrLinje == 0) cout << endl;
    skrivFlyttall(tabell[nr], presisjon, vidde);
    }
  cout << endl;
} // skrivData
                                  
//-------------------------------------------------------------------
//
// Funksjon for  lese et tall i det lukkede intervallet [nedre, ovre]
//
int lesTallIIntervall(
  int nedre,
  int ovre)
{
  if (nedre > ovre) {       // Bytter eventuelt om grensene
    int hjelp = nedre;
    nedre = ovre;
    ovre = hjelp;
    }
  int tall;
  cin >> tall;                                      
  while (tall < nedre || tall > ovre) {
    cout << "Ugyldig verdi. Skriv et tall i intervallet ["
      << nedre << "," << ovre << "] : ";
    cin >> tall;
    } // behandling av ugyldige inndata
  return tall;
} // lesTallIIntervall                                      

//-------------------------------------------------------------------
//
// Funksjon for  skrive et flyttall med et bestemt antall desimaler
// og en bestemt feltvidde
//
void skrivFlyttall(
  double tall,        // Inn
  int    presisjon,   // Inn
  int    feltvidde)   // Inn
{
  cout.setf(ios::fixed, ios::floatfield);
  int standardPresisjon = cout.precision(presisjon);
  cout << setw(feltvidde) << tall;
  cout.setf(0, ios::floatfield);  
  cout.precision(standardPresisjon);
} // skrivFlyttall

/* Kjreresultater

Hvor mange mlinger har du? 10
15.3
17.8
22.0
16.3
12.5
13.1
10.9
19.9
22.6
15.1
Antall mlinger: 10 Middelverdi: 16.55
Her er alle verdiene:
  15.30000  17.80000  22.00000  16.30000  12.50000
  13.10000  10.90000  19.90000  22.60000  15.10000

*/