//--------------------------------------------------------------------
//
// op9_10.cpp
//
// Program som finner de ti hyeste verdiene i en tabell ved  foreta
// delvis sortering.
//
#include <iostream>
#include <string>
using namespace std;

const int antallHoyeste = 10;
const int maksTabell = 200;

void instruksjoner();
void lagTabell(double *tabell, int &antall);
void sorterTabell(int antall, int antallHoyeste, double *tabell);
void skrivTabell(const double *tabell, int antall);

int main()
{
  instruksjoner();

  double tabell[maksTabell];
  int    antall;
  lagTabell(tabell, antall);
  if (antall >= antallHoyeste) {
    sorterTabell(antall, antallHoyeste, tabell);
    cout << "\nDe " << antallHoyeste << " hyeste elementer er : \n";
    skrivTabell(tabell, antallHoyeste);
    } // if
  else cout << "Feil: For f tall i tabellen!\n";
  return 0;
} // main


//--------------------------------------------------------------------
//
// Funksjon som lager tabellen
//
void lagTabell(
  double   *tabell,                    // Ut
  int      &antall)                    // Ut: Ant elementer i tabell

{
  antall = rand() % maksTabell;
  int teller = 0;
  while (teller < antall) {
    tabell[teller] = rand() % 10000;
    teller++;
    } // while
} // lesTabell

//--------------------------------------------------------------------
//
// Funksjon som sorterer en tabell i synkende rekkeflge
// Det sorteres bare p 'antallHoyeste' elementer
//
void sorterTabell(
  int     antall,                      // Inn: Ant elementer i tabell
  int     antallHoyeste,               // Inn: Sortert antall
                                       //      frst i tabellen  
  double *tabell)                      // Inn/Ut: Tabellen
{
  int start;
  int teller;
  int hittilStorst;

  if (antallHoyeste > antall) antallHoyeste = antall;
  for (start = 0; start < antallHoyeste; start++) {
    hittilStorst = start;
    for (teller = start + 1; teller < antall; teller++) {
      if (tabell[teller] > tabell[hittilStorst]) {
        hittilStorst = teller;
        } // if
      } // for teller
      double hjelp = tabell[hittilStorst];
      tabell[hittilStorst] = tabell[start];
      tabell[start] = hjelp;
    } // for start
} // sorterTabell

//--------------------------------------------------------------------
//
// Funksjon som skriver ut elementer fra en tabell
//
void skrivTabell(
  const double *tabell,                // Inn
  int           antall)                // Inn: Antall som skal skrives
{
  int i;
  for (i = 0; i < antall; i++) {
    cout << tabell[i] << " ";
    }
  cout << endl;
} // skrivTabell

//--------------------------------------------------------------------
//
// Funksjon som skriver ut instruksjoner
//
void instruksjoner()
{
  cout << "Jeg lager en tabell med usorterte tall ved hjelp av ";
  cout << "rand()-funksjonen.\nDeretter finner jeg de " << antallHoyeste;
  cout << " hyeste verdiene og skriver dem ut p\n";
  cout << "skjermen til deg.\n\n";
} // instruksjoner

/* Kjreresultat

Jeg lager en tabell med usorterte tall ved hjelp av rand()-funksjonen.
Deretter finner jeg de 10 hyeste verdiene og skriver dem ut p
skjermen til deg.


De 10 hyeste elementer er :
9961 9912 9895 9894 9718 9358 9169 8716 8703 8467

*/
