//--------------------------------------------------------------------
//
// op9_11.cpp
//
// Program som produserer resultatliste for en havseilerregatta
//
#include <iostream>
#include <iomanip>
#include <string>
using namespace std;

const int maksTabell = 20;
const int plassBreddeUtskrift = 5;
const int baatBreddeUtskrift = 20;
const int tidBreddeUtskrift = 10;
const int breddeUtskrift =
  plassBreddeUtskrift + baatBreddeUtskrift + tidBreddeUtskrift;
const int antDesimaler = 2;

//--------------------------------------------------------------------
void  lesTabell(string *navn, double *tid, int &antall);
void  sorterTabell(string *navn, double *tid, int antall);
void  skrivTabell(string *navn, double *tid, int antall);
void  skrivTegn(char tegn, int antall);

int main()
{
  string navn[maksTabell];
  double tid[maksTabell];
  int  antall;
  lesTabell(navn, tid, antall);
  sorterTabell(navn, tid, antall);
  cout << endl;
  skrivTabell(navn, tid, antall);
  return 0;
} // main


//--------------------------------------------------------------------
//
// Funksjon som leser inn tabellen
// Forutsetter at frste tall som leses inn er antall deltakere,
// deretter kommer data om hver bt (navn og tid), med to linjer for hver bt.
//
void lesTabell(
  string   *navn,                      // Ut
  double   *tid,                       // Ut
  int      &antall)                    // Ut: Ant elementer i tabell
{
  cin >> antall;
  cin.ignore();
  int nr;
  string navnet;
  string tiden;
  for (nr = 0; nr < antall; nr++) {
    getline(cin, navnet);
	navn[nr] = navnet;
    getline(cin, tiden);
	tid[nr] = atof(tiden.c_str());
    } // while
} // lesTabell

//--------------------------------------------------------------------
//
// Funksjon som sorterer en tabell i stigende rekkeflge
//
void sorterTabell(
  string *navn,                        // Inn/ut
  double *tid,                         // Inn/ut
  int   antall)                        // Inn: Ant elementer
{
  int    start;
  int    teller;
  int    hittilMinst;
  string hjelpNavn;
  double hjelpTid;

  for (start = 0; start < antall; start++) {
    hittilMinst = start;
    for (teller = start + 1; teller < antall; teller++) {
      if (tid[teller] < tid[hittilMinst]) {
        hittilMinst = teller;
        } // if
      } // for
      hjelpNavn = navn[hittilMinst];
      navn[hittilMinst] = navn[start];
      navn[start] = hjelpNavn;
      hjelpTid = tid[hittilMinst];
      tid[hittilMinst] = tid[start];
      tid[start] = hjelpTid;
    } // for
} // sorterTabell

//--------------------------------------------------------------------
//
// Funksjon som skriver ut btene og tidene
//
void skrivTabell(
  string *navn,                        // Inn
  double *tid,
  int    antall)                       // Inn: Antall som skal skrives
{
  skrivTegn('=', breddeUtskrift);
  cout << endl;
  cout << setw(plassBreddeUtskrift) << "Plass";
  cout << setw(baatBreddeUtskrift) << "Btens navn";
  cout << setw(tidBreddeUtskrift) << "Tid" << endl;
  skrivTegn('-', breddeUtskrift);
  cout << endl;

  int i;
  cout.setf(ios::fixed, ios::floatfield);
  for (i = 0; i < antall; i++) {
    cout << setw(plassBreddeUtskrift) << i + 1;
    cout << setw(baatBreddeUtskrift) << navn[i];
    cout << setw(tidBreddeUtskrift) << setprecision(antDesimaler);
	cout << tid[i] << endl;
    }

  skrivTegn('=', breddeUtskrift);
  cout << endl;
} // skrivTabell

//--------------------------------------------------------------------
//
// Funksjon som skriver et tegn
//
void skrivTegn(
  char tegn,                           // Inn
  int  antall)                         // Inn
{
  int i;
  for (i = 0; i < antall; i++) cout << tegn;
} // skrivTegn

/* Inndatafil

3
Ellen
4.73
Havets dronning
2.56
Hesten
3.00

*/

/* Kjreresultat

===================================
Plass         Btens navn       Tid
-----------------------------------
    1     Havets dronning      2.56
    2              Hesten      3.00
    3               Ellen      4.73
===================================

*/
