//-------------------------------------------------------------------
//
// op9_2
//
// Et program som leser temperaturmlinger, plasserer
// dem i en tabell, og finner antall dager i gitte temperaturintervaller
//

#include <iostream>   
#include <iomanip>
using namespace std;

const int    maksAntallMaalinger = 366;
const int    vidde = 5;   
const int    antallGrupper = 7;
const double grense[antallGrupper] =
  {-20.0, -10.0, 0.0, 10.0, 20.0, 30.0, 100000000.0};   
  
void plasser(const double *tabell, int antall, int *gruppe);
void lesData(int antall, double *tabell);                   
int  lesTallIIntervall(int nedre, int ovre);
int  finnGruppe(double temperatur);

//-------------------------------------------------------------------
int main()
{
  double   temp[maksAntallMaalinger];
  int      antallMaalinger;
  
  cout << "Hvor mange mlinger har du? ";
  antallMaalinger = lesTallIIntervall(0, maksAntallMaalinger);
  
  lesData(antallMaalinger, temp);  

  int gruppe[antallGrupper];
  plasser(temp, antallMaalinger, gruppe);

  for (int nr = 0; nr < antallGrupper - 1; nr++) {
    cout << "Opp til " << setw(vidde) << grense[nr] << " grader: ";
    cout << setw(vidde) << gruppe[nr] << endl;
    }
  cout << "Over    " << setw(vidde) << grense[antallGrupper - 2];
  cout << " grader: " << setw(vidde) << gruppe[antallGrupper - 1] << endl;
  return 0;
} // main

//-------------------------------------------------------------------
//
// Leser dataene.
//
void lesData(
  int       antall,       // Inn
  double   *tabell)       // Ut

{
  int nr;
  for (nr = 0; nr < antall; nr++) {
    cin >> tabell[nr];
    }
} // lesData

//-------------------------------------------------------------------
//
// Funksjon for  lese et tall i det lukkede intervallet [nedre, ovre]
//
int lesTallIIntervall(
  int nedre,
  int ovre)
{
  if (nedre > ovre) {       // Bytter eventuelt om grensene
    int hjelp = nedre;
    nedre = ovre;
    ovre = hjelp;
    }
  int tall;
  cin >> tall;                                      
  while (tall < nedre || tall > ovre) {
    cout << "Ugyldig verdi. Skriv et tall i intervallet ["
      << nedre << "," << ovre << "] : ";
    cin >> tall;
    } // behandling av ugyldige inndata
  return tall;
} // lesTallIIntervall                                      

//-------------------------------------------------------------------
//
// Teller opp antall temperaturer i hver gruppe.
//
void plasser(
  const double *tabell,   // Inn
  int           antall,   // Inn
  int          *gruppe)   // Ut
{
  int nr;
  int gruppeNr;

  for (gruppeNr = 0; gruppeNr < antallGrupper; gruppeNr++) {
    gruppe[gruppeNr] = 0;
    }
  for (nr = 0; nr < antall; nr++) {
    gruppeNr = 0;
    while (grense[gruppeNr] < tabell[nr]) gruppeNr++;
	gruppe[gruppeNr]++;
    }
} // plasser

/* Kjreresultater

Hvor mange mlinger har du? 10
-26
-13
-9
0
2
5
15
25
35
18
Opp til   -20 grader:     1
Opp til   -10 grader:     1
Opp til     0 grader:     2
Opp til    10 grader:     2
Opp til    20 grader:     2
Opp til    30 grader:     1
Over       30 grader:     1

*/
