//-------------------------------------------------------------------
//
// op9_3.cpp
//
// Et program som leser temperaturmlinger, plasserer
// dem i en tabell, og finner vrtypen p angitte dager
//

#include <iostream>
#include <string>
using namespace std;

const int maksAntallMaalinger = 366;
const int verdierPrLinje = 5;                  
const int presisjon = 5;
const int vidde = 10;   
const int antallGrupper = 7;
const int maksLengde = 20;
const double grense[antallGrupper] =
  {-20.0, -10.0, 0.0, 10.0, 20.0, 30.0, 100000000.0};   
  
const string karakteristikk[antallGrupper] = {
  "Bitende kaldt!",
  "Kald vinterdag",
  "Flott vinterdag",
  "Grnn vinter",
  "Kjlig sommerdag",
  "Fin sommerdag",
  "Tropevarme" };

void plasser(const double *tabell, int antall, int *gruppe);
void lesData(int antall, double *tabell);                   
int  lesTallIIntervall(int nedre, int ovre);
int  finnGruppe(double temperatur);

//-------------------------------------------------------------------
int main()
{
  double   temp[maksAntallMaalinger];
  int      antallMaalinger;
  
  cout << "Hvor mange mlinger har du? ";
  antallMaalinger = lesTallIIntervall(0, maksAntallMaalinger);
  
  lesData(antallMaalinger, temp);  

  int gruppe[antallGrupper];
  plasser(temp, antallMaalinger, gruppe);

  int dagNr;
  cout << "Angi et dagnummer, og du fr vite temperaturen den dagen";
  cout << endl << "(Skriv et ugyldig dagnummer for  avslutte)";
  cout  << endl;
  cin >> dagNr;
  dagNr--;
  while (dagNr >= 0 && dagNr < antallMaalinger) {
    cout << temp[dagNr] << " ";
    cout << karakteristikk[finnGruppe(temp[dagNr])] << endl;
    cin >> dagNr;
    dagNr--;
    }
  return 0;
} // main

//-------------------------------------------------------------------
//
// Leser dataene.
//
void lesData(
  int       antall,       // Inn
  double   *tabell)       // Ut

{
  int nr;
  for (nr = 0; nr < antall; nr++) {
    cin >> tabell[nr];
    }
} // lesData

//-------------------------------------------------------------------
//
// Funksjon for  lese et tall i det lukkede intervallet [nedre, ovre]
//
int lesTallIIntervall(
  int nedre,
  int ovre)
{
  if (nedre > ovre) {       // Bytter eventuelt om grensene
    int hjelp = nedre;
    nedre = ovre;
    ovre = hjelp;
    }
  int tall;
  cin >> tall;                                      
  while (tall < nedre || tall > ovre) {
    cout << "Ugyldig verdi. Skriv et tall i intervallet ["
      << nedre << "," << ovre << "] : ";
    cin >> tall;
    } // behandling av ugyldige inndata
  return tall;
} // lesTallIIntervall                                      

//-------------------------------------------------------------------
//
// Teller opp antall temperaturer i hver gruppe.
//
void plasser(
  const double *tabell,   // Inn
  int           antall,   // Inn
  int          *gruppe)   // Ut
{
  int nr;
  int gruppeNr;

  for (gruppeNr = 0; gruppeNr < antallGrupper; gruppeNr++) {
    gruppe[gruppeNr] = 0;
    }
  for (nr = 0; nr < antall; nr++) {
    gruppeNr = 0;
    while (grense[gruppeNr] < tabell[nr]) gruppeNr++;
    gruppe[gruppeNr]++;
    }
} // plasser
 
//-------------------------------------------------------------------
//
// Finner hvilken gruppe en temperatur tilhrer
//
int finnGruppe(
  double temperatur)   // Inn
{
  int gruppeNr = 0;

  while (grense[gruppeNr] < temperatur) gruppeNr++;
  return gruppeNr;
} // finnGruppe

/* Kjreresultat

Hvor mange mlinger har du? 10
-35
-25
-15
-5
5
15
25
35
0
10
Angi et dagnummer, og du fr vite temperaturen den dagen
(Skriv et ugyldig dagnummer for  avslutte)
1
-35 Bitende kaldt!
2
-25 Bitende kaldt!
3
-15 Kald vinterdag
4
-5 Flott vinterdag
5
5 Grnn vinter
6
15 Kjlig sommerdag
7
25 Fin sommerdag
8
35 Tropevarme
9
0 Flott vinterdag
10
10 Grnn vinter
0

*/