//-------------------------------------------------------------------
//
// op9_6.cpp
//
// Et program som leser temperaturmlinger og plasserer
// dem i en todimensjonal tabell. Tabellen viser temperaturene
// hver 6. time i dgnet for hver dag i en uke.
// Programmet beregner middeltemperaturen for hver dag, for hvert tidspunkt
// og for hele uka.
// En generell funkjon for middelverdiberegningene brukes.
//

#include <iostream>
using namespace std;

const int antallDager = 7;
const int antallMaalingerPrDoegn = 4;
const int vidde = 4;

double gjSnitt(const double *tabell, int antall);
void   lesData(int antall, double tabell[antallDager][antallMaalingerPrDoegn]);                   
void   skrivData(const double *tabell, int antall);
int    lesTallIIntervall(int nedre, int ovre);
void   skrivFlyttall(double tall, int presisjon, int vidde);

//-------------------------------------------------------------------
int main()
{

  double temp[antallDager][antallMaalingerPrDoegn];
  int    dagNr;
  int    maaleNr;
  double middel;
                           
  cout << "Skriv data for " << antallMaalingerPrDoegn << " mlinger i ";
  cout << antallDager << " dager:" << endl;
  lesData(antallDager, temp);

// Oppgave a
  for (dagNr = 0; dagNr < antallDager; dagNr++) {
    middel = gjSnitt(temp[dagNr], antallMaalingerPrDoegn);
    cout << "Dag nr  " << dagNr + 1 << " : " << middel << endl;
    }
  cout << endl;

// Oppgave b
  double hjelpDager[antallDager];
  double hjelpTid[antallMaalingerPrDoegn];

  for (maaleNr = 0; maaleNr < antallMaalingerPrDoegn; maaleNr++) {
    for (dagNr = 0; dagNr < antallDager; dagNr++) {
      hjelpDager[dagNr] = temp[dagNr][maaleNr];
      }
    hjelpTid[maaleNr] = gjSnitt(hjelpDager, antallDager);
    cout << "Tidspunkt nr " << maaleNr + 1 << " : " << hjelpTid[maaleNr] << endl;
    }
  cout << endl;

// oppgave c
  middel = gjSnitt(hjelpTid, antallMaalingerPrDoegn);
  cout << "Totalt: " << middel << endl;
  
  return 0;
} // main

//-------------------------------------------------------------------
//
// Leser temeraturdata.
// Forutsetter at det er et helt antall dgn
//
void lesData(
  int    antall,                                           // Inn
  double tabell[antallDager][antallMaalingerPrDoegn])     // Ut
{    
  int dagNr;
  for (dagNr = 0; dagNr < antall; dagNr++) {
    for (int maaleNr = 0; maaleNr < antallMaalingerPrDoegn; maaleNr++) {
      cin >> tabell[dagNr][maaleNr];
      }
   }
} // lesData

//-------------------------------------------------------------------
//
// Beregner gjennomsnittet av tabellverdiene
//
double gjSnitt(
  const double *tabell,   // Inn
  int           antall)   // Inn
{

  double middel = 0.0;
  int    nr;

  for (nr = 0; nr < antall; nr++) {
    middel += tabell[nr];
    }
  if (antall > 0) middel /= antall;
  return middel;
} // gjSnitt

                                  
//-------------------------------------------------------------------
//
// Funksjon for  lese et tall i det lukkede intervallet [nedre, ovre]
//
int lesTallIIntervall(
  int nedre,
  int ovre)
{
  if (nedre > ovre) {       // Bytter eventuelt om grensene
    int hjelp = nedre;
    nedre = ovre;
    ovre = hjelp;
    }
  int tall;
  cin >> tall;                                      
  while (tall < nedre || tall > ovre) {
    cout << "Ugyldig verdi. Skriv et tall i intervallet ["
      << nedre << "," << ovre << "] : ";
    cin >> tall;
    } // behandling av ugyldige inndata
  return tall;
} // lesTallIIntervall1

/* Kjreresultat

Skriv data for 4 mlinger i 7 dager:
10 12 17 15
5 15 25 15
10 11 12 13
12 15 18 17
10 18 23 21
15 20 28 25
19 20 16 13
Dag nr  1 : 13.5
Dag nr  2 : 15
Dag nr  3 : 11.5
Dag nr  4 : 15.5
Dag nr  5 : 18
Dag nr  6 : 22
Dag nr  7 : 17

Tidspunkt nr 1 : 11.5714
Tidspunkt nr 2 : 15.8571
Tidspunkt nr 3 : 19.8571
Tidspunkt nr 4 : 17

Totalt: 16.0714

*/