//-------------------------------------------------------------------
//
// op10_5_tid.cpp
//
// Klasse for  hndtere tidspunkt (klokkeslett)
//

#include <string>
using namespace std;

const long int antTimPrDogn = 24L;
const long int antSekPrTime = 3600L;
const long int antSekPrMin = 60L;
const long int makstid = antTimPrDogn * antSekPrTime - 1L;
const string   separator = ":";

class Tid {
  public:
    bool  settTid(                     // Sett tid, format "tt:mm:ss"
                                       // Retur false hvis ikke eksakt
                                       // 8 tegn, ellers ingen kontroll.
                                       // (Kan lages som kontrollen for
                                       // dato, se oppgave 10-4)
               string nyTid);          // Inn
    bool     settTid(                  // Sett tid i sek.
                                       // Retur false hvis > et dgn
               long int tiden);        // Inn
    string   finnTid1() const;         // Finn tid p format "tt:mm:ss"
    long int finnTid2() const;         // Finn tid i sek.
    int      sammenlikn(               // Retur -1, 0 eller +1, jmf. kap 10-5
               Tid detAndre) const;    // Inn
    Tid      subtraher(                // Alltid positiv
               Tid detAndre);          // Inn

    enum konstanter {
          tidStrLengde = 8
          };

  private:
    int finnTall(int pos) const;  // Plukker ut tall fra tid
    string tid;
}; // Tid

string toTegn(int tall);

//--------------------------------------------------------------------
bool Tid::settTid(string nyTid)
{
  if (nyTid.length() != tidStrLengde) return false;
  tid = nyTid;
  return true;
} // settTid

//--------------------------------------------------------------------
bool Tid::settTid(long int tiden)
{
  if (tiden < 0 || tiden > makstid) return false;  // RETUR.

  int tim = (int)(tiden / antSekPrTime);
  int min = (int)((tiden % antSekPrTime) / antSekPrMin);
  int sek = (int)(tiden % antSekPrMin);

  // Gjr om til 2 tegn
  string timer = toTegn(tim);
  string minutter = toTegn(min);
  string sekunder = toTegn(sek);

  // Sett sammen strengene til tid (p formen "tt:mm:ss")
  tid = timer + separator + minutter + separator + sekunder;
  return true;
} // settTid

//--------------------------------------------------------------------
string Tid::finnTid1() const
{
  return tid;
} // finnTid

//--------------------------------------------------------------------
long int Tid::finnTid2() const
{
  long int timer = finnTall(0);
  long int minutter = finnTall(3);
  long int sekunder = finnTall(6);

  return timer * antSekPrTime + minutter * antSekPrMin + sekunder;
} // finnTid

//--------------------------------------------------------------------
int Tid::sammenlikn(Tid detAndre) const
{
  long int avstand = finnTid2() - detAndre.finnTid2();
  if (avstand < 0) return -1;
  else if (avstand > 0) return 1;
  else return 0;
} // sammenlign

//--------------------------------------------------------------------
Tid Tid::subtraher(Tid detAndre)
{
  long int avstand = finnTid2() - detAndre.finnTid2();
  if (avstand < 0) avstand = -avstand; // absolutt tidsforskjell
  Tid hjelp;
  hjelp.settTid(avstand);
  return hjelp;
} // subtraher

//--------------------------------------------------------------------
//
// Funksjon som lager en streng p to tegn ut fra et tosifret tall
//
string toTegn(
        int tall)     // Inn
{
  int antTiere = tall / 10;
  int antEnere = tall % 10;
  string streng = "";
  string ettSiffer = "0"; // hjelpevariabel
  ettSiffer[0] = antTiere + '0'; // gjr om fra tall til tegn
  streng += ettSiffer;
  ettSiffer[0] = antEnere + '0';
  streng += ettSiffer;
  return streng;
} // toTegn

//-------------------------------------------------------------------
//
// Privat medlemsfunksjon som plukker ut et tall p to siffer fra
// tidspunktet. (Brukes til  finne hele timer,
// hele min. og hele sek.)
//
int Tid::finnTall(
           int pos) const    // Inn, startpos.
{
  long int hjelp = (tid[pos] - '0') * 10;
  hjelp += tid[pos + 1] - '0';
  return hjelp;
} // finnTall
