//-------------------------------------------------------------------
//
// op10_7_broek.cpp
//
// Klasse for  behandle brker.
// NB: Hvis en brk fr nevner 0 avluttes hele programmet!
// Alle brker som klassen lager returneres til klienten
// ferdig forkortet.
//
#include <string>
#include <cstdlib> 
#include <iostream>

using namespace std;

class Broek {
  public:  
    void    settBroek(
              int nyTeller,                 // Inn
              int nyNevner = 1);            // Inn
    int     finnTeller() const;
    int     finnNevner() const;                   
    Broek   adder(
              Broek denAndre) const;        // Inn
    Broek   subtraher(
              Broek denAndre) const;        // Inn
    Broek   multipliser(
              Broek denAndre) const;        // Inn
    Broek   divider(
              Broek denAndre) const;        // Inn
    void    adderTil(
              Broek denAndre);              // Inn
    void    subtraherFra(
              Broek denAndre);              // Inn
    void    multipliserMed(
              Broek denAndre);              // Inn
    void    dividerMed(
              Broek denAndre);              // Inn
    int     sammenlikn(  // -1, 0 eller +1, jamfr kap 10-5
               Broek denAndre) const; // Inn

  private:
    void forkort();
    int  teller;
    int  nevner;
  }; // Broek

//-------------------------------------------------------------------
//
// implementasjon
//
//-------------------------------------------------------------------
void Broek::settBroek(int nyTeller, int nyNevner) 
{
  if (nyNevner != 0) {
    teller = nyTeller;
    nevner = nyNevner;
    forkort();
    }
  else {
    cout << "Nevneren ble null! Avslutter.\n";
    exit(EXIT_FAILURE);
  }
} // settBroek

//-------------------------------------------------------------------
int Broek::finnTeller() const 
{
  return teller;
} // finnNevner

//-------------------------------------------------------------------
int Broek::finnNevner() const 
{
  return nevner;
} // finnTeller

//-------------------------------------------------------------------
Broek Broek::adder(Broek denAndre) const 
{
  Broek hjelp;
  hjelp.settBroek(teller, nevner);
  hjelp.adderTil(denAndre);
  return hjelp;
} // adder

//-------------------------------------------------------------------
void Broek::adderTil(Broek denAndre) 
{
  settBroek(teller * denAndre.nevner + nevner * denAndre.teller,
            nevner * denAndre.nevner);
} // adderTil

//-------------------------------------------------------------------
Broek Broek::subtraher(Broek denAndre) const 
{
  Broek hjelp;
  hjelp.settBroek(teller, nevner);
  hjelp.subtraherFra(denAndre);
  return hjelp;
} // subtraher

//-------------------------------------------------------------------
void Broek::subtraherFra(Broek denAndre) 
{
  settBroek(teller * denAndre.nevner - nevner * denAndre.teller,
            nevner * denAndre.nevner);
} // subtraherFra

//-------------------------------------------------------------------
Broek Broek::multipliser(Broek denAndre) const 
{
  Broek hjelp;
  hjelp.settBroek(teller, nevner);
  hjelp.multipliserMed(denAndre);
  return hjelp;
} // multipliser

//-------------------------------------------------------------------
void Broek::multipliserMed(Broek denAndre) 
{
  settBroek(teller * denAndre.teller, nevner * denAndre.nevner);
} // multipliserMed

//-------------------------------------------------------------------
Broek Broek::divider(Broek denAndre) const 
{
  Broek hjelp;
  hjelp.settBroek(teller, nevner);
  hjelp.dividerMed(denAndre);
  return hjelp;
} // divider

//-------------------------------------------------------------------
void Broek::dividerMed(Broek denAndre) 
{
  settBroek(teller * denAndre.nevner, nevner * denAndre.teller);
} // dividerMed

//-------------------------------------------------------------------
//
// Srger for at nevneren alltid er positiv, og brken mest mulig
// forkortet. Bruker Euclids algoritme for  finne fellesnevneren.
//
void Broek::forkort() 
{
  if (nevner < 0) {
    teller = -teller;
    nevner = -nevner;
    }
  int a = teller;
  int b = nevner;
  int c;
  if (a < 0) a = -a;

  while (b > 0) {
    c = a % b;
    a = b;
    b = c;
    }
  teller /= a;
  nevner /= a;
} // forkort

//-------------------------------------------------------------------
//
// Returnerer +1 hvis denne er > denAndre, 0 hvis de er like, -1 ellers
//
int Broek::sammenlikn(Broek denAndre) const 
{
  Broek hjelp;
  hjelp.settBroek(teller, nevner);
  hjelp.subtraherFra(denAndre);  // nevner alltid positiv, se forkort()
  if (hjelp.teller > 0) return 1;
  else if (hjelp.teller == 0) return 0;
  else return -1;
} // sammenlikn
