//-------------------------------------------------------------------
//
// op11_4.cpp
//
// Fletting av filer:
// ==================
// Programmet leser tall fra to filer. Tallene ligger sortert p
// filene. Alle tallene skrives til en tredje fil, slik at denne
// blir i sortert rekkeflge. Dubletter fjernes ikke.
//
// Antall tall pr linje p utfil beregnes ut fra konstantene 
// feltvidde og linjelengde.
//
// Filnavnene mottas fra tastaturet. Dersom en fil ikke kan pnes,
// blir programutfrelsen avbrutt.
//
#include <iostream>         
#include <iomanip>
#include <fstream>
#include <cstdlib>
#include <string>
using namespace std;

const int feltvidde = 6;
const int linjelengde = 70;
const int antallTallPrLinje = linjelengde / feltvidde;
const int antForsok = 3;

void aapneInnfil(int antForsok, ifstream &innfil);  // se kap 11-1
void aapneUtfil(ofstream &utfil);
void aapneFiler(ifstream &innfil1, ifstream &innfil2, ofstream &utfil);
void flettFiler(ifstream &innfil1, ifstream &innfil2, ofstream &utfil);
void lukkFiler(ifstream &innfil1, ifstream &innfil2, ofstream &utfil);
void behandle(ifstream &innfil, ofstream &utfil, int &tall, int &tallnr);
void avsluttMedFeilmelding(string tekst);
               
int main()
{
  ifstream innfil1;     // Den ene innfilen
  ifstream innfil2;     // Den andre innfilen
  ofstream utfil;       // Utfilen
  
  aapneFiler(innfil1, innfil2, utfil);
  flettFiler(innfil1, innfil2, utfil);
  lukkFiler(innfil1, innfil2, utfil);

  return 0;
} // main
                
//-------------------------------------------------------------------
//
// pner de tre filene som skal brukes i programmet.
//
void aapneFiler(
  ifstream &innfil1,    // Ut 
  ifstream &innfil2,    // Ut
  ofstream &utfil)      // Ut
{                           
  cout << "Den ene filen som data skal hentes fra : " << endl;
  aapneInnfil(antForsok, innfil1);
  cout << "Den andre filen som data skal hentes fra : " << endl;
  aapneInnfil(antForsok, innfil2);
  cout << endl << "Filen dataene skal sendes til : " << endl;
  aapneUtfil(utfil);
} // aapneFiler 

//-------------------------------------------------------------------
//
//  Fletter innfil1 og innfil2. Resultatet sendes til utfil.
//  
void flettFiler(
  ifstream &innfil1,    // Inn/ut
  ifstream &innfil2,    // Inn/ut
  ofstream &utfil)      // Inn/ut
{
  int tall1;   // Tall fra innfil1
  int tall2;   // Tall fra innfil2
  
  innfil1 >> tall1;
  innfil2 >> tall2;                                                  
  int tallnr = 0;   // Teller antall tall p linja (utfil)
  while (!innfil1.eof() && !innfil2.eof()) {
    if (tall1 < tall2) behandle(innfil1, utfil, tall1, tallnr);
    else behandle(innfil2, utfil, tall2, tallnr);
    }
  // Dersom det er slutt p begge filene vil ingen av while-
  // lkkene nedenfor gjennomlpes. Ellers er det slutt p
  // eksakt en av filene. While-lkka som behandler den filen
  // vil ikke gjennomlpes.
  while (!innfil1.eof()) behandle(innfil1, utfil, tall1, tallnr);
  while (!innfil2.eof()) behandle(innfil2, utfil, tall2, tallnr);
  innfil1.clear();
  innfil2.clear();
} // flettFiler      
               
//-------------------------------------------------------------------
//
// Lukker filene
//
void lukkFiler(
  ifstream &innfil1,        // Inn/ut
  ifstream &innfil2,        // Inn/ut
  ofstream &utfil)          // Inn/ut
{
  innfil1.close();
  innfil2.close();
  utfil.close();
} // lukkFiler    

//-------------------------------------------------------------------
//
// Sender tall til utfil, henter nytt tall fra innfil og oppdaterer
// iallnr.
//                     
void behandle(
  ifstream &innfil,      // Inn 
  ofstream &utfil,       // Inn
  int      &tall,        // Inn/Ut
  int      &tallnr)      // Inn/Ut
{
  utfil << setw(feltvidde) << tall;
  tallnr++;
  if (tallnr >= antallTallPrLinje) {
    utfil << endl;
    tallnr = 0;
    } 
  innfil >> tall;   
} // behandle  

//-------------------------------------------------------------------
void avsluttMedFeilmelding(
  string tekst)      // Inn
{      
  cout << tekst << endl;
  exit(EXIT_FAILURE);
} // avslutt  

//-----------------------------------------------------
//
// Leser navnet p en utfil fra brukeren. pner filen.
// Dersom filen ikke eksisterer, blir den automatisk
// opprettet.
//
void aapneUtfil(
  ofstream   &utfil)          // Ut
{
  cout << "Oppgi filnavn, utfil: ";
  string filnavn;
  cin >> filnavn;
  utfil.clear();
  utfil.open(filnavn.c_str());
  if (!utfil) {
    avsluttMedFeilmelding(
      "Gir opp  pne filen.\nAvbryter programutfrelsen.\n");
    }  
} // aapneUtfil    

//-----------------------------------------------------
//
// Denne funksjonen er identisk med den foran,
// men den pner en innfil.
//
void aapneInnfil(
  int         antForsok,      // Inn
  ifstream   &innfil)          // Ut
{
  cout << "Oppgi filnavn, innfil: ";
  string filnavn;
  cin >> filnavn;
  innfil.clear();
  innfil.open(filnavn.c_str());
  int forsokNr = 1;
  while (!innfil && forsokNr < antForsok) {
    cout << "Fr ikke pnet filen. " << 
      "Oppgi filnavnet en gang til: ";  
    cin >> filnavn;
    innfil.clear(); 
    innfil.open(filnavn.c_str());
    forsokNr++;
    }                  
  if (!innfil) {
    avsluttMedFeilmelding(
      "Gir opp  pne filen.\nAvbryter programutfrelsen.\n");
    }  
} // aapneInnfil    

/* Eksempelfiler:

test_inn.txt

-23 12 12 67 678
679 990

test_inn2.txt

67 676 756
990
991

Dette gir flgende resultatfil:

   -23    12    12    67    67   676   678   679   756   990   990
   991

*/


