//-------------------------------------------------------------------
//
// nctype.h
//
// Et supplement til standardfilen <cctype>.
//
// Funksjonene <ctype.h> virker korrekt bare innenfor den 
// standardiserte delen av ASCII-tabellen, dvs. i omrdet
// [0,127]. Vrt ml m vre at funksjonene skal virke korrekt
// innenfor omrdet [0,127] OG for de srnorske bokstavene
// ,  og . (, ,  og , ,  ligger utenfor omrdet [0,127])
//
// Funksjonene tar int-argument og returnerer datatypen int, p
// samme mten som funksjonene p <cctype>
//
// Funksjonsnavnene er de samme som p <cctype>, men med 
// forstavelse N
//                            
#ifndef TEGN_DEFINERT
  #define TEGN_DEFINERT
        
  // Flgende char-konstanter skal inneholde de srnorske tegnene
  // i rekkeflge, frst de sm, s de store:
  //
  const char litenAe = '';
  const char litenOe = '';
  const char litenAa = '';
  const char storAe = '';
  const char storOe = '';
  const char storAa = '';
        
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er en bokstav eller et siffer
  //
  int nisalnum(   
    int t);    // Inn      
          
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er en bokstav 
  //
  int nisalpha(   
    int t);    // Inn      
          
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er et kontrolltegn 
  // (ASCII-verdier 0-31 og 127)
  //
  int niscntrl(   
    int t);    // Inn      
          
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er et siffer
  //
  int nisdigit(   
    int t);    // Inn      
          
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er et skrivbart tegn annet
  // enn blank  (ASCII-verdier 33-126)
  //
  int nisgraph(          
    int t);    // Inn      
          
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er en liten bokstav
  //
  int nislower(       
    int t);    // Inn      
          
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er et skrivbart tegn inkl. blank
  // (ASCII-verdier 32-126)
  //
  int nisprint(          
    int t);    // Inn      
          
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er et skrivbart tegn annet enn
  // blank, bokstav og siffer (ASCII-verdier 33-47, 58-64, 91-96,
  // 123-126)
  //
  int nispunct(     
    int t);    // Inn      
  
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er et ordskille (ASCII-verdier
  // 9-13 og 32) 
  //
  int nisspace(     
    int t);    // Inn      
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er en stor bokstav
  //
  int nisupper(     
    int t);    // Inn      
  //-----------------------------------------------------------------
  //    
  // Returnerer logisk sant dersom t er et heksadesimalt siffer
  // (0-9, A-F)
  //
  int nisxdigit(     
    int t);    // Inn      

  //-----------------------------------------------------------------
  //
  // Returnerer "stor" versjon av t, hvis t er en liten bokstav.
  // Ellers returneres t uforandret.
  //
  int ntoupper(
    int t);    // Inn

  //-----------------------------------------------------------------
  //
  // Returnerer "liten" versjon av t, hvis t er en stor bokstav.
  // Ellers returneres t uforandret.
  //
  int ntolower(
    int t);    // Inn

#endif
