//--------------------------------------------------------------------
//
// op13_2.cpp
//
// Program som regner om fra romerske tall til arabiske
//
#include <iostream>
#include <string>
#include <cctype>
using namespace std;

string lagStoreBokstaver(string tekst); 
void instruksjoner();
bool romerskTilArabisk(string romersk, int &tallet);

int main()
{
  string romersk;
  cout << "Det romerske tallet: ";
  getline(cin, romersk);

  int tallet;
  if (romerskTilArabisk(romersk, tallet)) {
    cout << endl << romersk;
    cout << " er " << tallet << endl;
    }
  else cout << "Feil: Ikke noe romersk tall!\n";
  return 0;
} // main

//--------------------------------------------------------------------
//
// Funksjon som regner om fra romerske tall til arabiske
//
bool romerskTilArabisk(
  string romersk,                 // Inn
  int   &tallet)                  // Ut
{
  const int  tallVerdi[] = {1000, 500, 100, 50, 10, 5, 1 };
  const string bokstaver = "MDCLXVI";

  romersk = lagStoreBokstaver(romersk);  
  bool ok = true;
  int  i = 0;

  tallet = 0;

  while (i < romersk.length()) {
    int forste = bokstaver.find(romersk[i], 0);
    if (forste >= 0) {
      int andre = bokstaver.find(romersk[i + 1], 0);
      if (andre >= 0 && forste > andre) {
        tallet += (tallVerdi[andre] - tallVerdi[forste]);
        i += 2;
        }
      else {
        tallet += tallVerdi[forste];
        i++;
        }
      } // if
    else ok = false;
    } // while
  return ok;
} // romerskTilArabisk

//--------------------------------------------------------------------
//
// Funksjon som skriver ut instruksjoner
//
void instruksjoner()
{
  cout << "Du skriver et romersk tall til meg, og s skal jeg\n";
  cout << "finne det tilsvarende arabiske tallet.\n\n";
} // instruksjoner

//-------------------------------------------------------------------
//
// Funksjonen konverterer alle bokstavene i en tekststreng til store.
// Fra kapittel 6-2 i boka.
//
string lagStoreBokstaver(
  string tekst)          // Inn
{
  int antTegn = tekst.length();
  string nyTekst(antTegn, ' ');
  int teller;
  for (teller = 0; teller < antTegn; teller++) {
    char tegn = tekst[teller];
    if (tegn == '') tegn = '';
    else if (tegn == '') tegn = '';
    else if (tegn == '') tegn = '';
    else tegn = toupper(tegn);
    nyTekst[teller] = tegn;
    }
  return nyTekst;
} // lagStoreBokstaver
