//---------------------------------------------------------------------
//
// arbeidstaker.h
//
// Definerer klassen Arbeidstaker.
//
// Bruker klassene Navn og Dato. Begge finnes i eksempelsamlingen for
// dette kapitlet (kap. 14)
//
#ifndef ARBTAKER_DEFINERT
  #define ARBTAKER_DEFINERT
  #include <string>
  #include "navn.h"
  #include "dato.h"
  using namespace std;

  class Arbeidstaker {
    public:
      Arbeidstaker( // ansattdato settes til dagens dato
        const Navn &initNavn,         // Inn
        const Dato &initFDato);       // Inn

      Arbeidstaker(
        const Navn &initNavn,         // Inn
        const Dato &initFDato,        // Inn
        const Dato &initAnsDato,      // Inn
        long int    initTlf,          // Inn
        long int    initLoenn,        // Inn
        double      initSkPros,       // Inn
        long int    initArbTakNr);    // Inn


      void settAnsDato(
            const Dato &nyDato);     // Inn

      void settTlf(
            long int nyTlf);         // Inn

      void settLoenn(
            long int nyLoenn);       // Inn

      bool settSkPros(   // m vre tall mellom 0 og 100
              double nyPros);        // Inn

      void settArbTakNr(
              long int nyttNr);      // Inn

      const Navn &finnNavn() const;
      const Dato &finnFDato() const;
      const Dato &finnADato() const;
      long int    finnTlf() const;
      long int    finnLoenn() const;
      double      finnSkPros() const;
      long int    finnArbTakNr() const;

      int         finnAntallAarAnsatt() const;
      bool        eldreEnn(
                    const Arbeidstaker &denAndre) const;
      bool        ansattLengerEnn(
                    const Arbeidstaker &denAndre) const;

      string      lagUtskrift() const;

    private:
      Navn     navn;
      Dato     fdato;
      Dato     ansDato;
      long int tlf;
      long int loenn;
      double   prosent;
      long int arbtakernr;
  }; // Arbeidstaker
#endif           l






