//---------------------------------------------------------------------
//
// arbeidstakerHoved.cpp
//
// Oppgaven lses ved at datafilen leses flere ganger.
// Et alternativ er  lese dataene inn i minnet og lagre dem i en tabell.
// Tabellstrrelsen br da bestemmes etter at man har funnet ut
// hvor mye data som ligger p filen. For  f til det m tabellen
// ligge i det frie lageret, se kap. 16-6
//

#include <fstream>
#include <iostream>
#include <string>
#include <iomanip>

#include "dato.h"
#include "navn.h"
#include "arbeidstaker.h"
#include "datafil.h"

using namespace std;

const string filnavn = "arbtaker.txt";
const int grenseAnsattLenge = 5; // r

int main()
{
  cout.setf(ios::fixed, ios::floatfield);  // fast format ved utskrift av desimaltall
  Datafil filen(filnavn);

  cout << "\nAntall ansatte er " << filen.finnAntAnsatte() << endl << endl;

  Dato dato = filen.finnFDatoEldst();
  cout << "Eldste arbeidstaker:\n" << filen.lagUtskriftSammeFDato(dato) << endl;

  dato = filen.finnAnsDatoAnsLengst();
  cout << "Ansatt lengst:\n" << filen.lagUtskriftSammeAnsDato(dato) << endl;

  cout << "Personer ansatt lenger enn " << grenseAnsattLenge << " r.\n" <<
          filen.lagUtskriftAnsLengerEnnAar(grenseAnsattLenge) << endl;

  cout << "Gjennomsnittlig skatteprosent er " << setprecision(2) << 
           filen.finnSnittSkatteprosent() << endl;
} // main

/* Utskrift:

Antall ansatte er 7

Eldste arbeidstaker:
Navn: Per  Hansen, fdt: 06071960, ansatt: 10122002
Tlf: 42565678, lnn: 330000, skatteprosent: 36.00

Navn: Iver  Hansen, fdt: 06071960, ansatt: 01022002
Tlf: 48565678, lnn: 330000, skatteprosent: 36.00


Ansatt lengst:
Navn: Even  Utus, fdt: 07081984, ansatt: 01071999
Tlf: 42789666, lnn: 331000, skatteprosent: 36.00

Navn: Pernille  +s, fdt: 07081982, ansatt: 01071999
Tlf: 42789056, lnn: 330000, skatteprosent: 31.00


Personer ansatt lenger enn 5 r.
Navn: Even  Utus, fdt: 07081984, ansatt: 01071999
Tlf: 42789666, lnn: 331000, skatteprosent: 36.00

Navn: Ole  Olsen, fdt: 10081980, ansatt: 10122000
Tlf: 42345678, lnn: 300000, skatteprosent: 30.00

Navn: Pernille  +s, fdt: 07081982, ansatt: 01071999
Tlf: 42789056, lnn: 330000, skatteprosent: 31.00

Navn: Ingrid  Jensen, fdt: 09041982, ansatt: 01072000
Tlf: 49345678, lnn: 340000, skatteprosent: 30.00


Gjennomsnittlig skatteprosent er 32.00
*/
