//---------------------------------------------------------------------
//
// datafil.h
//
// Hver funksjon leser gjennom dafilen fra begynnelse til slutt.
// Filen pnes i konstruktren og lukkes i destruktren.
// Funksjonene kan ikke vre const pga at de alle sammen
// endrer p fil-objektet (flytter filpekeren mm.)
//
//
#ifndef DATAFIL_DEFINERT
  #define DATAFIL_DEFINERT
  #include <string>
  #include <fstream>
  #include "navn.h"
  #include "dato.h"
  #include "arbeidstaker.h"
  using namespace std;

  class Datafil {
    public:
      Datafil(   // pner filen
        const string &initFilnavn);       // Inn
      ~Datafil();   // lukker filen
      
      Dato   finnFDatoEldst();
      Dato   finnAnsDatoAnsLengst();
      string lagUtskriftSammeFDato(
               const Dato &dato);   // Inn
      string lagUtskriftSammeAnsDato(
               const Dato &dato);   // Inn
      string lagUtskriftAnsLengerEnnAar(
               int antallAar);      // Inn
      double finnSnittSkatteprosent();
      int    finnAntAnsatte();

    private:
      bool     lesObjekt( // leser et objekt fra filen
                 Arbeidstaker &obj);      // Ut
      ifstream fil;

  }; // Datafil
#endif






