//-------------------------------------------------------------------
//
// dato.h  E.L. 2005-02-01
//              2006-04-03 tilpasset lreboka i C++
//
// Klasse for hndtering av datoer. Datoer kan sammenliknes (like,
// fr, etter), og det er mulig  finne antall dager mellom to datoer.
//
// Flgende feilkontroll utfres i konstruktrer og sett-funksjoner:
//
// Aar >= 0.
// 1 <= Mnd <= 12.
// Dag >= 1.
// For Mnd = 1,3,5,7,8,10,12 skal Dag <= 31.
// For Mnd = 4,6,9,11 skal Dag <= 30
// For Mnd = 2 skal Dag <= 28 hvis ikke skuddr, <= 29 ellers.
//
#ifndef DATO_DEFINERT
  #define DATO_DEFINERT

  #include <string>
  using namespace std;

  class Dato {
    public:
      // Klienten br bruke erOk() for  sjekke at en gyldig dato
      // ble lagt inn. De vrige funksjonene (unntatt settDato())
      // forutsetter at det er tilfelle.

      Dato(
        int nyDag,            // Inn
        int nyMnd,            // Inn
        int nyttAar);         // Inn

      Dato(
        const string &nyDato);          // Inn, format: ddmmaaaa

      Dato();  // dagens dato

      bool     erOk() const;

      // Funksjonene returnerer false dersom datoen er ugyldig
      bool     settDato(
                 int nyDag,             // Inn
                 int nyMnd,             // Inn
                 int nyttAar);          // Inn

      bool     settDato(
                 const string &nyDato); // Inn, Format: ddmmaaaa

      void     settDato(); // dagens dato

      int      finnDag() const;
      int      finnMnd() const;
      int      finnAar() const;

      void     finnDato(
                 int &dagen,            // Ut
                 int &mnden,            // Ut
                 int &aaret)const;      // Ut

      string   finnDato() const;

      long int antallDagerTil(
                 const Dato &denAndre) const; // Inn

      // Funksjonen sammenlikner to datoer:
      // Returverdi: 0 hvis likhet, <0 hvis DenAndre etter,
      // >0 hvis DenAndre fr den datoen funksjonen kalles p vegne av.
      int      sammenlikn(
                 const Dato &denAndre) const; // Inn

    private:
      int  dag;
      int  mnd;
      int  aar;
      bool ok;
    };
#endif

