//-------------------------------------------------------------------
//
// penge_t.cpp - hovedprogram
//
#include <iostream>
#include <string>
#include "penge.h"

using namespace std;

const int maksAntall = 10;

ostream &operator<<(ostream &ut, const Penger &penger);
istream &operator>>(istream &inn, Penger &penger);

bool  finnUtHvaBarnaSkalBetale(Penger gaveKoster, int antall,
                               const Penger *barnHar, Penger *barnSkalBetale);
void     instruksjoner();
void     lesInn(int antall, const string &ledetekst1, const string &ledetekst2, Penger *tabell);

int main()
{
  Penger barnHar[maksAntall];
  Penger skalBetale[maksAntall];
  Penger gaveKoster;
  int    antall = 0;

  instruksjoner();

  cout << "\n\nHvor mye koster gaven ? ";
  cin >> gaveKoster;
  cout << "Hvor mange barn skal vre med  betale gaven? ";
  cin >> antall;
  if (antall > 0 && antall <= maksAntall) {
    cout << endl;
    lesInn(antall, "Barn ", " har: ", barnHar);
    cout << endl;
    bool ok =
      finnUtHvaBarnaSkalBetale(gaveKoster, antall, barnHar, skalBetale);
    if (ok) {
      for (int i = 0; i < antall; i++) {
        cout << "Barn " << i + 1 << " skal betale : " ;
        cout << skalBetale[i] << endl;
        } // for
      } // if
    else cout << "Barna har for lite penger!";
    }
  else cout << "Feil: Antall [1, " << maksAntall << "]\n";
  return 0;
} // main

//-------------------------------------------------------------------
//
// operator >> leser inn penger (pund shilling pence)
//

//-------------------------------------------------------------------
istream &operator>>(istream &inn, Penger &penger)
{
  int pence;
  int pund;
  int shilling;
  cin >> pund;
  cin >> shilling;
  cin >> pence;
  penger.settBelop(pund, shilling, pence);
  return inn;
} // operator>>

//-------------------------------------------------------------------
//
// operator << skriver ut penger (pund, shilling og pence)
//
ostream &operator<<(ostream &ut, const Penger &penger)
{
  int pund;
  int shilling;
  int pence;
  penger.finnBelop(pund, shilling, pence);
  if (pund > 0) {
    ut << pund << " pund";
    if (shilling > 0 && pence > 0) ut << ", ";
    else if (shilling > 0 || pence > 0) ut << " og ";
    }
  if (shilling > 0) {
    ut << shilling << " shilling";
    if (pence > 0) ut << " og ";
    }
  if (pence > 0) ut << pence << " pence";
  return ut;
} // operator<<

//-------------------------------------------------------------------
//
// Les inn i tabell et 'antall' av klassen penger
//
void lesInn(
  int     antall,             // Inn
  const string &ledetekst1,   // Inn
  const string &ledetekst2,   // Inn
  Penger *tabell)             // Ut
{
  for (int i = 0; i < antall; i++) {
    cout << ledetekst1 << i + 1;
    cout << ledetekst2;
    cin >> tabell[i];
    } // for
} // lesInn

//-------------------------------------------------------------------
//
// Finner ut hva barna skal betale. Returnerer false hvis de har for
// lite penger tilsammen.
//
bool finnUtHvaBarnaSkalBetale(
  const Penger &gaveKoster,
  int           antall,
  const Penger *barnHar,
  Penger       *barnSkalBetale)
{
  Penger sortert[maksAntall];
  for (int i = 0; i < antall; i++) sortert[i] = barnHar[i];
  for (int start = 0; start < antall - 1; start++) {
    int hittilMinst = start;
    for (int teller = start + 1; teller < antall; teller++) {
      if (sortert[teller] < sortert[hittilMinst]) hittilMinst = teller;
      }
    Penger hjelp = sortert[hittilMinst];
    sortert[hittilMinst] = sortert[start];
    sortert[start] = hjelp;
    }
  int nr = 0;
  Penger skalBetale = gaveKoster / antall;
  Penger harBetalt;
  harBetalt.settAntPence(0);
  while (nr < antall - 1 && sortert[nr] < skalBetale) {
    harBetalt += sortert[nr];
    skalBetale = (gaveKoster - harBetalt) / (antall - nr - 1);
    nr++;
    }
  if (sortert[antall - 1] >= skalBetale) {
    for (nr = 0; nr < antall; nr++) {
      if (barnHar[nr] < skalBetale) barnSkalBetale[nr] = barnHar[nr];
      else barnSkalBetale[nr] = skalBetale;
      }
    return true;
    }
  else return false;
} // finnUtHvaBarnSkalBetale

//-------------------------------------------------------------------
//
// Funksjon som gir instruksjoner til bruker
//
void instruksjoner()
{
  cout << "Programmet  spr  hvor  mye gaven  koster og hvor mange\n";
  cout << "penger hvert barn har. Hvis de har nok penger tilsammen\n";
  cout << "gir programmet  beskjed  om hvor  mye hvert enkelt barn\n";
  cout << "skal betale.  Alle som har rd til det betaler like mye\n";
  cout << "mens de som har for lite, betaler s mye som de har.\n";
} // instruksjoner


/* Kjreresultat
Programmet  spr  hvor  mye gaven  koster og hvor mange
penger hvert barn har. Hvis de har nok penger tilsammen
gir programmet  beskjed  om hvor  mye hvert enkelt barn
skal betale.  Alle som har rd til det betaler like mye
mens de som har for lite, betaler s mye som de har.


Hvor mye koster gaven ? 23 15 10
Hvor mange barn skal vre med  betale gaven? 5

Barn 1 har: 10 0 0
Barn 2 har: 5 10 3
Barn 3 har: 3 10 0
Barn 4 har: 3 15 8
Barn 5 har: 3 5 0

Barn 1 skal betale : 7 pund, 14 shilling og 11 pence
Barn 2 skal betale : 5 pund, 10 shilling og 3 pence
Barn 3 skal betale : 3 pund og 10 shilling
Barn 4 skal betale : 3 pund, 15 shilling og 8 pence
Barn 5 skal betale : 3 pund og 5 shilling
*/