//--------------------------------------------------------------------
//
// op16_1.cpp
//
// Program som summerer samhrende elementer i to tabeller.
// Summene legges i en tredje tabell.
//
#include <iostream>
#include <cstddef>
using namespace std;

void instruksjoner();
void adderTabeller(int antall, const int *forste, const int *andre, 
                   int *resultat);
int main()
{
  instruksjoner();

  cout << "Hvor mange elementer i tabellene? ";
  int antall;
  cin >> antall;
  if (antall > 0) {
    int *forste   = new int[antall];
    int *andre    = new int[antall];
    int *resultat = new int[antall];

    if (forste != 0 && andre != 0 && resultat != 0) {
      // Les tall og legg dem inn i tabell forste og andre
      int i;
      for (i = 0; i < antall; i++) {
        cout << "forste " << i + 1<< ". : ";
        cin >> *(forste + i);
        cout << "andre  " << i + 1<< ". : ";
        cin >> *(andre + i);
        } // for

      // Summer tabellene, og plasser svaret i tabell sum
      adderTabeller(antall, forste, andre, resultat);

      // Skriv ut resultat
      cout << "\n\nSvaret blir for hvert enkelt element :\n";
      for (i = 0; i < antall; i++) {
        cout << "sum " << i + 1 << ". = " << *(resultat + i) << endl;
        } // for

      // Slett tabellene fra minnet
      delete [] forste;
      delete [] andre;
      delete [] resultat;
      forste = 0;
      andre = 0;
      resultat = 0;
      }
    else cout << "Feil: Var ikke nok tilgjengelig minne.\n";
    }
  else cout << "Feil: Tabellen m ha flere enn 0 elementer!\n";
  
  return 0;
} // main

//--------------------------------------------------------------------
//
// Funksjon som legger sammen elementer fra to tabeller og legger
// svaret i en ny tabell
//
void adderTabeller(
  int        antall,                   // Inn: Antall elementer
  const int *forste,                   // Inn
  const int *andre,                    // Inn
  int       *resultat)                 // Ut
{
  int i;
  for (i = 0; i < antall; i++) {
    *(resultat + i) = *(forste + i) + *(andre + i);
    } // for
} // adderTabeller

//--------------------------------------------------------------------
//
// Funksjon som skriver ut instruksjoner
//
void instruksjoner()
{
  cout << "Du skal skrive inn to tabller med tall og jeg skal \n";
  cout << "addere dem og skrive ut resultatet.\n\n";
} // instruksjoner

/* Kjreresultater
Du skal skrive inn to tabller med tall og jeg skal
addere dem og skrive ut resultatet.

Hvor mange elementer i tabellene? 4
forste 1. : 2
andre  1. : 5
forste 2. : 6
andre  2. : -7
forste 3. : 0
andre  3. : 4
forste 4. : 1
andre  4. : 1


Svaret blir for hvert enkelt element :
sum 1. = 7
sum 2. = -1
sum 3. = 4
sum 4. = 2

*/