//--------------------------------------------------------------------
//
// op16_2.cpp
//
// Program som leser inn en rekke tall i en tabell og skriver dem ut
// i motsatt rekkeflge
//
#include <iostream>
#include <fstream>
#include <cmath>
#include <string>
using namespace std;

const int maksTabell = 200;

void   instruksjoner();
string lesLinje(const string &ledetekst);
int    lesTabellFraFil(int maksAntall, ifstream &innfil, 
                     double *tabell);
void skrivTabellTilFil(const double *tabell, int fra, int til, 
                       ofstream &utfil);

int main()
{
  instruksjoner();

  ifstream innfil;
  ofstream utfil;

  string linje = lesLinje("Innfilnavn: ");
  innfil.open(linje.c_str());
  if (!innfil) {
     cout << "Feil: Filen finnes ikke!\n";
   }
  else {
    linje = lesLinje("Utfilnavn: ");
    utfil.open(linje.c_str());
    double tabell[maksTabell];
    int antall = lesTabellFraFil(maksTabell, innfil, tabell);
    if (antall > 0) skrivTabellTilFil(tabell, antall - 1, 0, utfil);
    innfil.close();
    utfil.close();
  }
  return 0;
} // main

//--------------------------------------------------------------------
//
// Funksjon som leser inn ei linje
//
string lesLinje(
  const string &ledeTekst)            // Inn
{
  cout << ledeTekst;
  string linje;
  getline(cin, linje);
  return linje;
} // lesLinje

//--------------------------------------------------------------------
//
// Funksjon som leser inn linjer med tall fra fil og legger dem
// i en tabell
//
int lesTabellFraFil(
  int       maksAntall,                // Inn
  ifstream &innfil,                    // Inn
  double   *tabell)                    // Ut
{
  int antall = 0;
  double tall;
  innfil >> tall;
  while (!innfil.eof() && antall < maksAntall) {
    *(tabell + antall) = tall;
    antall++;
	innfil >> tall;
    } // while
  return antall;
} // lesTabellFraFil

//--------------------------------------------------------------------
//
// Funksjon som skriver ut tabell til fil
//
void skrivTabellTilFil(
  const double *tabell,                // Inn
  int           fra,                   // Inn
  int           til,                   // Inn
  ofstream     &utfil)                 // Inn/ut
{
  if (fra > til) {
    for (int i = fra; i >= til; i--) {
      utfil << *(tabell + i) << endl;
      } // for
    }
  else {
    for (int i = fra; i <= til; i++) {
      utfil << *(tabell + i) << endl;
      } // for
    } // if
} // skrivTabellTilFil

//--------------------------------------------------------------------
//
// Funksjon som skriver ut instruksjoner
//
void instruksjoner()
{
  cout << "Programmet leser  inn fra fil en rekke tall  lagret p\n";
  cout << "hver sin linje og legger dem inn i en tabell. Tabellen\n";
  cout << "blir s skrevet ut i omvendt rekkeflge til en ny fil.\n";
  cout << endl;
} // instruksjoner

/*Kjreresultat
Programmet leser  inn fra fil en rekke tall  lagret p
hver sin linje og legger dem inn i en tabell. Tabellen
blir s skrevet ut i omvendt rekkeflge til en ny fil.

Innfilnavn: inn.txt
Utfilnavn: ut.txt

inn.txt
1
2
3
4
5
6
7
8
9
10

ut.txt
I Visual Studio 6.0:

9
8
7
6
5
4
3
2
1

I g++:

10
9
8
7
6
5
4
3
2
1

Visula Studio 6.0 flger ikke standarden. Den gir eof nr vi leser siste linje, 
mens standarden sier at vi skal f eof nr vi prver  lese etter at siste
linje er lest

*/