//---------------------------------------------------------------------
//
// op16_4.cpp
//
// Funksjoner som kan erstatte noen av funksjonene i string
//
#include <iostream>
#include <cstddef>
using namespace std;

const char *finnForsteForekomstAvTegn(const char *tekst, char tegn);
const char *finnSisteForekomstAvTegn(const char *tekst, char tegn);
const char *finnSisteForekomstAvTegn(const char *tekst, char tegn, const char *start);
const char *finnDelstreng(const char *tekst, const char *delstreng);
                              
const char *tekst = "atrallalla lla la tralala"; 

int main()
{                
  const char *peker = finnForsteForekomstAvTegn(tekst, 'a');
  while (peker != 0) {
    cout << "a i posisjon " << peker - tekst << endl;
    peker = finnForsteForekomstAvTegn(peker + 1, 'a');
    }
  peker = finnSisteForekomstAvTegn(tekst, 'a');
  while (peker != 0) {
    cout << "a i posisjon " << peker - tekst << endl;
    peker = finnSisteForekomstAvTegn(tekst, 'a', peker - 1);
    }
  peker = finnDelstreng(tekst, "alla");
  while (peker != NULL) {
    cout << "alla i posisjon " << peker - tekst << endl;
    peker = finnDelstreng(peker + 1, "alla");
    }  
  peker = finnDelstreng(tekst, "galla");
  while (peker != 0) {
    cout << "galla i posisjon " << peker - tekst << endl;
    peker = finnDelstreng(peker + 1, "galla");
    }
  return 0;
} // main  

//-------------------------------------------------------------------
//
// Funksjonen returnerer en peker til frste forekomst av tegn i 
// tekst. Funksjonen leter fram til nulltermineringstegnet. Den
// returnerer 0 hvis tegnet ikke finnes.
//
const char *finnForsteForekomstAvTegn(
  const char *tekst,     // Inn
  char        tegn)      // Inn
{                              
  while (*tekst != tegn && *tekst != '\0') tekst++;
  if (*tekst == tegn) return tekst;
  else return 0;
} // finnForsteForekomstAvTegn

//-------------------------------------------------------------------
//
// Funksjonen returnerer en peker til siste forekomst av tegn i 
// tekst. Funksjonen leter fram til nulltermineringstegnet. 
// Den returnerer 0 hvis tegnet ikke finnes.
//
                                            
const char *finnSisteForekomstAvTegn(
  const char *tekst,     // Inn
  char        tegn)      // Inn
{
  const char *start = tekst;
  while (*start != '\0') start++;
  return finnSisteForekomstAvTegn(tekst, tegn, start);
} // finnSisteForekomstAvTegn 
                             
//-------------------------------------------------------------------
//
// Funksjonen returnerer en peker til siste forekomst av tegn i 
// tekst. Funksjonen leter forover. 
// Den returnerer 0 hvis tegnet ikke finnes.
//
                                            
const char *finnSisteForekomstAvTegn(
  const char *tekst,     // Inn
  char        tegn,      // Inn
  const char *start)     // Inn
{
  while (start > tekst && *start != tegn) start--;
  if (*start == tegn) return start;
  else return 0;
} // finnSisteForekomstAvTegn 
//-------------------------------------------------------------------
//
// Funksjonen returnerer en peker til frste forekomst av delstreng
// i tekst. Funksjonen leter fram til nulltermineringstegnet. Den
// returnerer 0 hvis delstrengen ikke finnes.                 
//
const char *finnDelstreng(
  const char *tekst,      // Inn
  const char *delstreng)  // Inn
{ 
  // Finner lengden til delstrengen
  int lengdeDelstreng = 0;
  while (*(delstreng + lengdeDelstreng) != '\0') lengdeDelstreng++;
                                   
  // Sker etter frste tegn i delstrengen. Deretter ser vi om resten
  // stemmer.
  bool funnet = false; // Settes lik true hvis vi finner delstrengen
  const char *posisjon = finnForsteForekomstAvTegn(tekst, *delstreng);
  while (!funnet && posisjon != 0) { 
    int antall = 1;  // For  telle antall tegn som passer
    while (antall < lengdeDelstreng && 
          *(posisjon + antall) == *(delstreng + antall)) {
      antall++;
      }
    if (antall == lengdeDelstreng) funnet = true;
    else {   // Prver p nytt
      posisjon = finnForsteForekomstAvTegn(posisjon + 1, *delstreng);        
      }                                              
    }                                
    return posisjon;
} // finnDelstreng

/* Kjreresultat
a i posisjon 0
a i posisjon 3
a i posisjon 6
a i posisjon 9
a i posisjon 13
a i posisjon 16
a i posisjon 20
a i posisjon 22
a i posisjon 24
I finnSiste
a i posisjon 24
I finnSiste
a i posisjon 22
I finnSiste
a i posisjon 20
I finnSiste
a i posisjon 16
I finnSiste
a i posisjon 13
I finnSiste
a i posisjon 9
I finnSiste
a i posisjon 6
I finnSiste
a i posisjon 3
I finnSiste
a i posisjon 0
I finnSiste
alla i posisjon 3
alla i posisjon 6
*/