//-----------------------------------------------------------------------------
//
// Tall.h
//
// Klasse for  administrere store positive tall.
//
// Kan hntere tall med vilkrlig antall siffer.
// Alle operasjonene forutsetter at tallene er ok.
//
// Subtraksjon forutsetter at resultatet blir positivt eller 0.
//
// Tekster som skal omformes til tall, kan ikke inneholde
// andre tegn enn 0-9, heller ikke blanke.
//
#ifndef TALL_DEFINERT
  #define TALL_DEFINERT
  #include <fstream>
  #include <vector>

  using namespace std;
  
  class Tall {
    public:
      Tall();
      Tall(
        const string &initTall);                 // Inn  
      Tall(
        int initTall);                           // Inn
      string  finnTall() const;  
      Tall    operator+(
                const Tall &detAndre) const;     // Inn
      Tall    operator-(
                const Tall &detAndre) const;     // Inn
      Tall   &operator+=(
                const Tall &detAndre);           // Inn
      Tall   &operator-=(
                const Tall &detAndre);           // Inn
      bool operator<(
                const Tall &detAndre) const;     // Inn
      bool operator<=(
                const Tall &detAndre) const;     // Inn
      Tall   &operator++(void);

    private:   
      int sammenlikn(const Tall &detAndre) const;
      vector<int> sifrene;
    }; // Tall
#endif    
  
//-----------------------------------------------------------------------------
//
// Ikke-medlemsfunksjoner
//
ostream& operator<<(
  ostream    &Ut,       // Inn/ut
  const Tall &Tall);    // Inn

//-----------------------------------------------------------------------------
istream& operator>>(
  istream &Inn,         // Inn/ut
  Tall    &Tall);       // Ut
