//-------------------------------------------------------------------
//
// lag_datafil.cpp - lager binrfil med tre mnstre
//
#include <iostream>
#include "moenster.h"

using namespace std;

int main()
{
  string filnavn = "moenstersamling.dat";

  Moenster::farge tab1[Moenster::hoyde][Moenster::bredde] = 
    {{ Moenster::hvit, Moenster::svart, Moenster::svart, Moenster::svart, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::svart, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::svart, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::roed, Moenster::svart, Moenster::hvit, Moenster::roed}};

  Moenster::farge tab2[Moenster::hoyde][Moenster::bredde] = 
    {{ Moenster::hvit, Moenster::svart, Moenster::svart, Moenster::svart, Moenster::roed},
     { Moenster::svart, Moenster::hvit, Moenster::roed, Moenster::svart, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::svart, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::roed, Moenster::svart, Moenster::hvit, Moenster::roed}};

  Moenster::farge tab3[Moenster::hoyde][Moenster::bredde] = 
    {{ Moenster::hvit, Moenster::svart, Moenster::svart, Moenster::svart, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::svart, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::roed, Moenster::svart, Moenster::hvit, Moenster::roed}};

  Moenster *m = new Moenster[3];
  m[0].settMoenster(tab1);
  m[1].settMoenster(tab2);
  m[2].settMoenster(tab3);
  
  // testutskrifter
  int i;
  for (i = 0; i < 3; i++) {
    cout << "Mnster " << i << ": \n";
    cout << "Antall hvite ruter: " << m[i].finnAntRuter(Moenster::hvit) << endl;
    cout << "Antall rde ruter: " << m[i].finnAntRuter(Moenster::roed) << endl;
    cout << "Antall svarte ruter: " << m[i].finnAntRuter(Moenster::svart) << endl;
    } // for

  // lagrer mnstrene p filen
  fstream datafil;
  datafil.open(filnavn.c_str(), ios::out | ios::binary); 
  if (!datafil) {
    cerr << "Fr ikke laget  filen\n";
    exit(EXIT_FAILURE);
    }
  
  for (i = 0; i < 3; i++) skrivTilBinFil(datafil, m[i]);
  datafil.close();

  return 0;
} // main

/* Utskrift:
Mnster 0:
Antall hvite ruter: 6
Antall rde ruter: 11
Antall svarte ruter: 8
Mnster 1:
Antall hvite ruter: 7
Antall rde ruter: 10
Antall svarte ruter: 8
Mnster 2:
Antall hvite ruter: 7
Antall rde ruter: 11
Antall svarte ruter: 7
*/