//-------------------------------------------------------------------
//
// Moenster.h
//
// Klasser for ett mnster og for en samling av mnstre.
//

#ifndef MOENSTER_DEFINERT
  #define MOENSTER_DEFINERT

  #include <fstream>
  #include <vector>

  using namespace std;

    //
    // Klassen Moenster
    //
    class Moenster {
      public:
        enum farge {hvit = 0, roed = 1, svart = 2};
        enum moensterStr {bredde = 5, hoyde = 5};

        Moenster();  // m etterflges av settMoenster
        Moenster(
          const farge initTabell[hoyde][bredde]);            // Inn

        void     settMoenster(
                   const farge initTabell[hoyde][bredde]);   // Inn
        void     finnMoenster(
                   farge tabell[hoyde][bredde]) const;       // Ut

        int      finnAntRuter(farge fargen) const;

        // Sammenlikningsoperatorer.
        // Antall rde og svarte ruter i  mnstrene sammenliknes.
        // Mnster med f rde ruter skal komme foran mnstre med
        // mange rde ruter. Har to mnstre like mange rde ruter,
        // kommer det mnster med frrest svarte ruter frst.  
        // Hvis antallet rde og antallet svarte ruter er like,
        // s er mnstrene like.

        bool     operator==(
                   const Moenster &detAndre) const;    // Inn
        bool     operator!=(
                   const Moenster &detAndre) const;    // Inn
        bool     operator>(
                   const Moenster &detAndre) const;    // Inn
        bool     operator>=(
                   const Moenster &detAndre) const;    // Inn
        bool     operator<(
                   const Moenster &detAndre) const;    // Inn
        bool     operator<=(
                   const Moenster &detAndre) const;    // Inn
        

      private:
        int     sammenlikn(
                  const Moenster &detAndre) const;     // Inn
        farge   tabell[hoyde][bredde];
    }; // Moenster

    //-----------------------------------------------------------------
    //
    // Skriving til skjerm
    //
    ostream &operator<<(
               ostream        &ut,           // Inn/ut
               const Moenster &moenster);    // Inn

    //-----------------------------------------------------------------
    //
    // Funksjoner for  lese fra og skrive til binrfil
    //
    bool lesFraBinFil(
               fstream  &datafil,            // Inn/ut
               Moenster &moenster);          // Ut

    void skrivTilBinFil(
               fstream        &datafil,      // Inn/ut
               const Moenster &moenster);    // Inn

    //-----------------------------------------------------------------
    //
    // Klassen Moenstersamling
    //
    class Moenstersamling {
      public:
        Moenstersamling(
          const string &filnavn);
        ~Moenstersamling();

        bool            settInnNyttMoenster(  // false hvis mnsteret fins fra fr
                          const Moenster &nyttMoenster);     // Inn
        int             finnAntMoenstre() const;
        const Moenster *finnMoenster(
                          int indeks) const;                 // Inn

       int              finnMoenster(
                          const Moenster &moensteret) const; // Inn

       void            sorter();  

      private:
        bool             sortert;
        fstream          datafil;
        vector<Moenster> samling;
    }; // Moenstersamling

#endif
