//-------------------------------------------------------------------
//
// test_moenster.cpp - lite testprogram
// Aller frst m du kjre programmet p lag_datafil.cpp.
//
#include <iostream>
#include "moenster.h"

using namespace std;

void lagSamling(Moenstersamling *samlingen);

int main()
{
  string filnavn = "moenstersamling.dat";
  Moenstersamling *samlingen = new Moenstersamling(filnavn);

  Moenster::farge tabell[Moenster::hoyde][Moenster::bredde] = 
    {{ Moenster::hvit, Moenster::svart, Moenster::svart, Moenster::svart, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::roed, Moenster::svart},
     { Moenster::hvit, Moenster::svart, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::roed, Moenster::svart, Moenster::roed, Moenster::roed}};

  Moenster m;
  m.settMoenster(tabell);
  // Dette lykkes bare frste gang - 
  if (samlingen->settInnNyttMoenster(m)) {
    cout << "Forsk 1: Mnster er satt inn.\n";
    }
  else cout << "Forsk 1: Mnster er ikke satt inn.\n";

  // Prver  sette inn det samme mnsteret en gang til, det skal ikke lykkes
  if (samlingen->settInnNyttMoenster(m)) {
    cout << "Forsk 2: Mnster er satt inn.\n";
    }
  else cout << "Forsk 2: Mnster er ikke satt inn.\n";

  cout << "Mnstrene usortert:\n";
  for (int i = 0; i < samlingen->finnAntMoenstre(); i++) {
    const Moenster *mPeker = samlingen->finnMoenster(i);
    int antHvite = mPeker->finnAntRuter(Moenster::hvit);
    int antRoede = mPeker->finnAntRuter(Moenster::roed);
    int antSvarte = mPeker->finnAntRuter(Moenster::svart);
    cout << "Mnster med indeks " << i << ": "<< antRoede 
         << " rde, " << antSvarte << " svarte, "  << antHvite << " hvite.\n";
    cout << *mPeker << endl;
    }

  // Sorterer

  samlingen->sorter();

  cout << "\nMnstrene sortert:\n";
  for (int i = 0; i < samlingen->finnAntMoenstre(); i++) {
    const Moenster *mPeker = samlingen->finnMoenster(i);
    cout << "Mnster med indeks " << i << endl;
    int antHvite = mPeker->finnAntRuter(Moenster::hvit);
    int antRoede = mPeker->finnAntRuter(Moenster::roed);
    int antSvarte = mPeker->finnAntRuter(Moenster::svart);
    cout << "Mnster med indeks " << i << ": "<< antRoede 
         << " rde, " << antSvarte << " svarte, "  << antHvite << " hvite.\n";
    cout << *mPeker << endl;
    }

  // Sker - mnster fra lag_datafil.cpp
  Moenster::farge tab2[Moenster::hoyde][Moenster::bredde] = 
    {{ Moenster::hvit, Moenster::svart, Moenster::svart, Moenster::svart, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::svart, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::roed, Moenster::svart, Moenster::hvit, Moenster::roed}};
  Moenster m2;
  m2.settMoenster(tab2);
  int indeks = samlingen->finnMoenster(m2);
  cout << "Mnsteret fins p indeks: " << indeks << endl;

  // Sker etter mnster som ikke finnes
  Moenster::farge tab3[Moenster::hoyde][Moenster::bredde] = 
    {{ Moenster::hvit, Moenster::hvit, Moenster::svart, Moenster::svart, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::svart, Moenster::roed, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::svart, Moenster::roed, Moenster::hvit, Moenster::roed},
     { Moenster::hvit, Moenster::roed, Moenster::svart, Moenster::hvit, Moenster::roed}};
  Moenster m3;
  m3.settMoenster(tab3);
  int antHvite = m3.finnAntRuter(Moenster::hvit);
  int antRoede = m3.finnAntRuter(Moenster::roed);
  int antSvarte = m3.finnAntRuter(Moenster::svart);
  cout << "\nMnsteret har "<< antRoede << " rde, " << antSvarte 
       << " svarte, "  << antHvite << " hvite.\n";

  indeks = samlingen->finnMoenster(m3);
  cout << "\nMnsteret skal settes inn p indeks\n"
       << "(neg. fortegn betyr at mnsteret ikke fins fra fr): " << indeks << endl;

  // Rydder
  delete samlingen;
  return 0;
} // main

/* Utskrift
Forsk 1: Mnster er satt inn.
Forsk 2: Mnster er ikke satt inn.
Mnstrene usortert:
Mnster med indeks 0: 11 rde, 8 svarte, 6 hvite.
hvit  svart svart svart rd
svart rd   rd   svart rd
svart rd   rd   hvit  rd
hvit  svart rd   hvit  rd
hvit  rd   svart hvit  rd


Mnster med indeks 1: 10 rde, 8 svarte, 7 hvite.
hvit  svart svart svart rd
svart hvit  rd   svart rd
svart rd   rd   hvit  rd
hvit  svart rd   hvit  rd
hvit  rd   svart hvit  rd


Mnster med indeks 2: 11 rde, 7 svarte, 7 hvite.
hvit  svart svart svart rd
svart rd   rd   hvit  rd
svart rd   rd   hvit  rd
hvit  svart rd   hvit  rd
hvit  rd   svart hvit  rd


Mnster med indeks 3: 12 rde, 8 svarte, 5 hvite.
hvit  svart svart svart rd
svart rd   rd   hvit  rd
svart rd   rd   rd   svart
hvit  svart rd   hvit  rd
hvit  rd   svart rd   rd



Mnstrene sortert:
Mnster med indeks 0
Mnster med indeks 0: 10 rde, 8 svarte, 7 hvite.
hvit  svart svart svart rd
svart hvit  rd   svart rd
svart rd   rd   hvit  rd
hvit  svart rd   hvit  rd
hvit  rd   svart hvit  rd


Mnster med indeks 1
Mnster med indeks 1: 11 rde, 7 svarte, 7 hvite.
hvit  svart svart svart rd
svart rd   rd   hvit  rd
svart rd   rd   hvit  rd
hvit  svart rd   hvit  rd
hvit  rd   svart hvit  rd


Mnster med indeks 2
Mnster med indeks 2: 11 rde, 8 svarte, 6 hvite.
hvit  svart svart svart rd
svart rd   rd   svart rd
svart rd   rd   hvit  rd
hvit  svart rd   hvit  rd
hvit  rd   svart hvit  rd


Mnster med indeks 3
Mnster med indeks 3: 12 rde, 8 svarte, 5 hvite.
hvit  svart svart svart rd
svart rd   rd   hvit  rd
svart rd   rd   rd   svart
hvit  svart rd   hvit  rd
hvit  rd   svart rd   rd

Mnsteret fins p indeks: 1

Mnsteret har 11 rde, 6 svarte, 8 hvite.

Mnsteret skal settes inn p indeks
(neg. fortegn betyr at mnsteret ikke fins fra fr): -1

*/