//---------------------------------------------------------------------
//
// ansatte.cpp - implementasjonsfil
//
#include <string>
#include "ansatte.h"

using namespace std;

Ansatt::Ansatt(const string &initNavn, const string &initFDato)
      : navn(initNavn),
        fdato(initFDato)
{ } // Ansatt

//---------------------------------------------------------------------
const string &Ansatt::finnNavn() const
{
  return navn;
} // finnNavn

//---------------------------------------------------------------------
const string &Ansatt::finnFDato() const
{
  return fdato;
} // finnFDato

//---------------------------------------------------------------------
string Ansatt::finnKlasse() const
{
  return "Ansatt";
} // finnKlasse

//---------------------------------------------------------------------
TeknPers::TeknPers(const string &initNavn, const string &initFDato,
                   const string &initSpesOmr)
        : Ansatt(initNavn, initFDato),
          spesialOmraade(initSpesOmr)
{ } // TeknPers

//---------------------------------------------------------------------
const string &TeknPers::finnSpesOmr() const
{
  return spesialOmraade;
} // finnSpesOmr

//---------------------------------------------------------------------
char TeknPers::finnArbAvtale() const
{
  return 'A';
} // finnArbAvtale

//---------------------------------------------------------------------
string TeknPers::finnKlasse() const
{
  return "TeknPers";
} // finnKlasse

//---------------------------------------------------------------------
Laerer::Laerer(const string &initNavn, const string &initFDato,
               const string &initFagkrets)
        : Ansatt(initNavn, initFDato),
          fagkrets(initFagkrets)
{ } // Laerer

//---------------------------------------------------------------------
const string &Laerer::finnFagkrets() const
{
  return fagkrets;
} // finnFagkrets

//---------------------------------------------------------------------
char Laerer::finnArbAvtale() const
{
  return 'B';
} // Laerer

//---------------------------------------------------------------------
string Laerer::finnKlasse() const
{
  return "Laerer";
} // finnKlasse

//---------------------------------------------------------------------
AdmAns::AdmAns(const string &initNavn, const string &initFDato)
      : Ansatt(initNavn, initFDato)
{ } // AdmAns

//---------------------------------------------------------------------
char AdmAns::finnArbAvtale() const
{
  return 'C';
} // AdmAns

//---------------------------------------------------------------------
string AdmAns::finnKlasse() const
{
  return "AdmAns";
} // finnKlasse

//---------------------------------------------------------------------
Sekretaer::Sekretaer(const string &initNavn, const string &initFDato,
                     const string &initSystem)
        : AdmAns(initNavn, initFDato),
          system(initSystem)
{ } // Sekretaer

//---------------------------------------------------------------------
const string &Sekretaer::finnSystem() const
{
  return system;
} // finnSystem

//---------------------------------------------------------------------
string Sekretaer::finnKlasse() const
{
  return "Sekretaer";
} // finnKlasse

//---------------------------------------------------------------------
AndreAdmAns::AndreAdmAns(const string &initNavn, const string &initFDato)
           : AdmAns(initNavn, initFDato)
{ } // AndreAdmAns

//---------------------------------------------------------------------
string AndreAdmAns::finnKlasse() const
{
  return "AndreAdmAns";
} // finnKlasse
