//---------------------------------------------------------------------
//
// test_ansatte.cpp - testprogram
//
#include <string>
#include <iostream>
#include "ansatte.h"

using namespace std;

int main()
{
  TeknPers tek("Ole Olsen", "12121980", "Linux-servere");
  Laerer laer("Petter Ulsund", "10081983", "C/C++/C#");
  Sekretaer sek("Ivar Ivarsen", "05061980", "EQS");
  AndreAdmAns adm("Per Persen", "10121983");

  const int antAnsatte = 4;
  Ansatt   *ansatte[antAnsatte];
  ansatte[0] = &tek;
  ansatte[1] = &laer;
  ansatte[2] = &sek;
  ansatte[3] = &adm;

  // Her viser vi hvordan vi bruker funksjonen finnKlasse() til  kalle
  // funksjoner som bare fins i enkelte av klassene.
  // For  f til utskriften nedenfor kunne vi alternativt ha
  // laget en skrivData()-funksjon p samme mte som for eksemplet i boka.
  
  for (int i = 0; i < antAnsatte; i++) {
    cout << "Navn: " << ansatte[i]->finnNavn() << ", fdt: " 
         << ansatte[i]->finnFDato() << ", arbeidsavtale: " 
         << ansatte[i]->finnArbAvtale();
    if (ansatte[i]->finnKlasse() == "Laerer") {
      Laerer *laerer = (Laerer *) ansatte[i];
      cout << ", fagkrets: " << laerer->finnFagkrets();
      }
    else if (ansatte[i]->finnKlasse() == "TeknPers") {
      TeknPers *teknisk = (TeknPers *) ansatte[i];
      cout << ", spesialomrde: " << teknisk->finnSpesOmr();
      }
    else if (ansatte[i]->finnKlasse() == "Sekretaer") {
      Sekretaer *sekr = (Sekretaer *) ansatte[i];
      cout << ", system: " << sekr->finnSystem();
      }
    cout << endl;
    } // for

  return 0;
} // main

/* Utskrift:

Navn: Ole Olsen, fdt: 12121980, arbeidsavtale: A, spesialomrde: Linux-servere
Navn: Petter Ulsund, fdt: 10081983, arbeidsavtale: B, fagkrets: C/C++/C#
Navn: Ivar Ivarsen, fdt: 05061980, arbeidsavtale: C, system: EQS
Navn: Per Persen, fdt: 10121983, arbeidsavtale: C
*/
