//-------------------------------------------------------------------
//
// bibliotek.cpp - implementasjonsfil
//

#include "bibliotek.h"

Bibliotek::Bibliotek()
{ } // Bibliotek

//---------------------------------------------------------------------
Bibliotek::~Bibliotek()
{
  for (int i = 0; i < (int) boeker.size(); i++) {
    delete boeker[i];
  }
} // ~Bibliotek

//---------------------------------------------------------------------
bool Bibliotek::registrerNyBok(const Bok *&nyBok)
{
  for (int i = 0; i < (int) boeker.size(); i++) {
    if (boeker[i]->finnIsbn() == nyBok->finnIsbn()) return false; // RETUR
    }
  boeker.push_back(nyBok);
  nyBok = 0;
  return true;
} // registrerNyBok

//---------------------------------------------------------------------
int Bibliotek::finnAntallBoeker() const
{
  return (int) boeker.size();
} // antallBoeker

//---------------------------------------------------------------------
const Bok *Bibliotek::finnBok(int indeks) const
{
  if (indeks >= 0 && indeks < (int) boeker.size()) {
    return boeker[indeks];
    }
  else return 0;
} // finnBok

//---------------------------------------------------------------------
vector<const Bok *> Bibliotek::finnBoeker(const string &tittel) const
{
  vector<const Bok *> resultat;
  for (int i = 0; i < (int) boeker.size(); i++) {
    if (boeker[i]->finnTittel() == tittel) {
      resultat.push_back(boeker[i]);
      }
    }
  return resultat;
} // finnBoeker