//---------------------------------------------------------------------
//
// test_oppg_b.cpp - testprogram
//
#include <string>
#include <vector>
#include <iostream>
#include "boeker.h"
#include "bibliotek.h"

using namespace std;

int main()
{
  Bibliotek bibliotek;
  Bok *bokpeker = 0;

  string *fTab = new string[2];
  fTab[0] = "Georgia Byng";
  fTab[1] = "John Erik Be Lindgren";
  bokpeker = new Barnebok("Molly Moons eventyrlige tidsreise", fTab, 2, 2005, 249,
               366, "8203247598", "Norge", 10, 17);
  delete [] fTab;
  bibliotek.registrerNyBok(bokpeker);

  fTab = new string[1];
  fTab[0] = "Georgia Byng";
  bokpeker = new Barnebok("Molly Moons eventyrlige tidsreise", fTab, 1, 2003, 220,
               310, "8243247598", "Norge", 10, 17);
  delete [] fTab;
  bibliotek.registrerNyBok(bokpeker);

  fTab = new string[3];
  fTab[0] = "Nicholas C. Zakas";
  fTab[1] = "Jeremy McPeak";
  fTab[2] = " Jeremy McPeak";
  bokpeker = new Fagbok("Professional AJAX", fTab, 3, 2006, 319,
               406, "0471777781", "USA", Fagbok::data);
  delete [] fTab;
  bibliotek.registrerNyBok(bokpeker);

  fTab = new string[1];
  fTab[0] = "Bukowski, Charles";
  bokpeker = new Skjoennlitteraer("Postkontoret", fTab, 1, 2001, 89, 166,
    "8205297134", "Norge", Skjoennlitteraer::samtidsroman);
  delete [] fTab;
  bibliotek.registrerNyBok(bokpeker);

  int i;
  for (i = 0; i < bibliotek.finnAntallBoeker(); i++) {
    cout << "Bok med indeks " << i << endl << 
             bibliotek.finnBok(i)->lagUtskrift() << endl << endl;
    }

  // Sker etter tittel vi vet det fins to av
  vector<const Bok *> res = bibliotek.finnBoeker("Molly Moons eventyrlige tidsreise");
  cout << "Resultat fra sk:\n";
  for (i = 0; i < (int) res.size(); i++) {
    cout << res[i]->lagUtskrift() << endl << endl;
    }
  return 0;
} // main

/* Utskrift:

Bok med indeks 0
Type bok: Barnebok
Forfatter(e): Georgia Byng, John Erik Be Lindgren
Tittel: Molly Moons eventyrlige tidsreise
Utgitt: 2005 i Norge, isbn: 8203247598, ant sider: 366, pris: 249kr., aldersgrup
pe: 10 - 17 r

Bok med indeks 1
Type bok: Barnebok
Forfatter(e): Georgia Byng
Tittel: Molly Moons eventyrlige tidsreise
Utgitt: 2003 i Norge, isbn: 8243247598, ant sider: 310, pris: 220kr., aldersgrup
pe: 10 - 17 r

Bok med indeks 2
Type bok: Fagbok
Forfatter(e): Nicholas C. Zakas, Jeremy McPeak,  Jeremy McPeak
Tittel: Professional AJAX
Utgitt: 2006 i USA, isbn: 0471777781, ant sider: 406, pris: 319kr., emne: data

Bok med indeks 3
Type bok: Skjnnlitteratur
Forfatter(e): Bukowski, Charles
Tittel: Postkontoret
Utgitt: 2001 i Norge, isbn: 8205297134, ant sider: 166, pris: 89kr., sjanger: sa
mtidsroman

Resultat fra sk:
Type bok: Barnebok
Forfatter(e): Georgia Byng, John Erik Be Lindgren
Tittel: Molly Moons eventyrlige tidsreise
Utgitt: 2005 i Norge, isbn: 8203247598, ant sider: 366, pris: 249kr., aldersgrup
pe: 10 - 17 r

Type bok: Barnebok
Forfatter(e): Georgia Byng
Tittel: Molly Moons eventyrlige tidsreise
Utgitt: 2003 i Norge, isbn: 8243247598, ant sider: 310, pris: 220kr., aldersgrup
pe: 10 - 17 r

*/