//-------------------------------------------------------------------
//
// nytte.cpp  - implementasjonsfil
//                               
#include <iostream>
#include <iomanip>
#include <cctype>
#include <cstdlib>
#include <string>
#include "nytte.h"
using namespace std;

//-------------------------------------------------------------------
string lesLinje(istream &inn)   
{
  // Hopper over eventuelle ordskiller 
  // (blank, linjeskift, etc. ) fr teksten begynner
  char nesteTegn = inn.peek();
  while (isspace(nesteTegn)) {
    inn.ignore();
    nesteTegn = inn.peek();
    }
  string linje;
  getline(inn, linje);
  return linje;
} // lesLinje

//-------------------------------------------------------------------
void skrivFlyttall(ostream &ut, double tall, int presisjon, int feltvidde)
{
  ut.setf(ios::fixed, ios::floatfield);
  int standardPresisjon = ut.precision(presisjon);
  ut << setw(feltvidde) << tall;
  ut.setf(0, ios::floatfield);
  ut.precision(standardPresisjon);
} // skrivFlyttall

//-------------------------------------------------------------------
int lesMenyvalg(string menytekst, string lovligValg)
{
  char valg;
  cout << endl << menytekst << endl << "Skriv et av tegnene " 
       << lovligValg << ": ";
  cin >> valg;
    
  int indeks;
  bool lovlig = false;
  while (!lovlig) {
    indeks = lovligValg.find(toupper(valg));
    if (indeks == string::npos) indeks = lovligValg.find(tolower(valg));
    if (indeks != string::npos) lovlig = true;
    else { // verken stor eller liten bokstav er funnet
      cout << "Ulovlig valg - skriv " << lovligValg << ": ";
      cin >> valg;
      } 
    }          
  return indeks;
}// lesMenyvalg

//-------------------------------------------------------------------
int lesTallIIntervall(int nedre, int ovre)
{             
  if (nedre > ovre) {     // bytter eventuelt om grensene
    int hjelp = nedre;
    nedre = ovre;
    ovre = hjelp;
    }
  int tall;                      
  cin >> tall;             
  while (tall < nedre || tall > ovre) {
    cout << "Ugyldig verdi. Skriv et tall i intervallet <"
      << nedre << "," << ovre << "> : ";
    cin >> tall;
    } // behandling av ugyldige inndata                
  return tall;  
} // lesTallIIntervall

//-------------------------------------------------------------------
void avsluttMedFeilmelding(string tekst)  
{      
  cout << tekst << endl;
  exit(EXIT_FAILURE);
} // avslutt
