//-------------------------------------------------------------------
//
// samling_av_publ.cpp - implementasjonsfil
//

#include "samling_av_publ.h"

PublSamling::PublSamling()
{ } // PublSamling

//---------------------------------------------------------------------
PublSamling::~PublSamling()
{
  for (int i = 0; i < (int) publikasjoner.size(); i++) {
    delete publikasjoner[i];
  }
} // ~PublSamling

//---------------------------------------------------------------------
bool PublSamling::registrerNyPublikasjon(Publikasjon *&nyPubl)
{
  for (int i = 0; i < (int) publikasjoner.size(); i++) {
    if (publikasjoner[i]->finnTittel() == nyPubl->finnTittel()) {
      return false; // RETUR
      }
    } // for

  publikasjoner.push_back(nyPubl);
  nyPubl = 0;
  return true;
} // registrerNyPublikasjon

//---------------------------------------------------------------------
int PublSamling::finnAntallPublikasjoner() const
{
  return (int) publikasjoner.size();
} // finnAntallPublikasjoner

//---------------------------------------------------------------------
const Publikasjon *PublSamling::finnPublikasjon(int indeks) const
{
  if (indeks >= 0 && indeks < (int) publikasjoner.size()) {
    return publikasjoner[indeks];
    }
  else return 0;
} // finnPublikasjon

//---------------------------------------------------------------------
const Publikasjon *PublSamling::finnPublikasjon(const string &tittel) const
{
  for (int i = 0; i < (int) publikasjoner.size(); i++) {
    if (publikasjoner[i]->finnTittel() == tittel) {
      return publikasjoner[i];  // RETUR
      }
    } // for
  return 0;
} // finnPublikasjon

//---------------------------------------------------------------------
bool PublSamling::registrerNyDatoForedrag(const string &tittel, 
                                          const string &nyDato)
{
  for (int i = 0; i < (int) publikasjoner.size(); i++) {
    if (publikasjoner[i]->finnTittel() == tittel) {
      if (publikasjoner[i]->finnPublikasjonstype() == "Foredrag") {
        Foredrag *pf = (Foredrag *) publikasjoner[i];
        pf->registrerNyDato(nyDato);
        return true;   // RETUR
        } 
      else return false; // RETUR (riktig tittel, men ikke foredrag)
      }
    } // for
  return false;  // tittel ikke funnet
} // registrerNyDatoForedrag
